/****************************************************************/
/****************************************************************/
/*******************    C E N T U R Y   I    ********************/
/****************************************************************/
/******** Last Change:  14.9.90                           *******/ 
/******** (c) & (w) by Claudio Pitrella und Andreas Fuchs *******/
/****************************************************************/
/****************************************************************/

#include <exec/exec.h>
#include <math.h>
#include <graphics/gfxbase.h>
#include <graphics/rastport.h>
#include <intuition/intuitionbase.h>
#include <libraries/dos.h>
#include <devices/trackdisk.h>
#include <libraries/dosextens.h>

#define FLAECHENWINKEL 70
#define FLAECHENWINKEL2 120
#define FLAECHENWINKEL3 30
#define DOWN 1
#define UP 2
#define abs(x) (x<0) ? -x : x;

#define Glas1ON s_1=1;
#define Glas2ON s_2=1;
#define Flummi1ON s_8=1;
#define Holz2ON s_6=1;
#define Holz1ON s_5=1;
#define Metal1ON s_4=1;
#define Metal2ON s_3=1;
#define EinsammelON s_9=1;

#define EISEN m=30000.0; Prall=-0.25;
#define FLUMMI m=2500.0; Prall=-0.65;
#define HOLZ m=18000.0; Prall=-0.35;
#define GLAS m=10000.0; Prall=-0.25;

extern struct MsgPort *CreatePort();
struct IOExtTD *request;
struct MsgPort *port;

UWORD *CollDat=0xdff00e;
UWORD *CLXCon=0xdff098;

UWORD *Zufall=0xdff006;

UWORD FinishX1[10];
UWORD FinishY1[10];
UWORD FinishX2[10];
UWORD FinishY2[10];

struct Level22 {
		char NameBauka[30];
		UBYTE AufbauData[8][12];
		long LevelMaxTime;   
		
		UWORD XKugel;
		UWORD YKugel;
		
		UBYTE Key;
		UWORD KeyX;
		UWORD KeyY;
		
 		UBYTE Leben;
		UWORD LebenX;
		UWORD LebenY;
		
		UBYTE LevelSchwer;
		UWORD LevelXSchwer;
		UWORD LevelYSchwer;			};

struct StoryBoard {
	struct Level22 Level[100]; 
		  };

struct StoryBoard *StoryBoard;

/*********************  Die Musi spuiln loassn !! ************************/
struct FuchsTracker {
        UBYTE name[10];
        ULONG AllInstrLength;
        UWORD Laenge_Instr[16];
        UWORD Volume[16];
        UWORD Loop[16];
        UWORD PatternAnz;
        UWORD Positions[40]; };
        
struct FuchsTracker *Track;

int Fast=6;

UWORD *Noten;
UWORD *Instruments;

UWORD *DMACon=0xdff096;

ULONG *Adresse1=0xdff0a0;
UWORD *Laenge1=0xdff0a4;
UWORD *Period1=0xdff0a6;
UWORD *Volume1=0xdff0a8;

ULONG *Adresse2=0xdff0b0;
UWORD *Laenge2=0xdff0b4;
UWORD *Period2=0xdff0b6;
UWORD *Volume2=0xdff0b8;

ULONG *Adresse3=0xdff0c0;
UWORD *Laenge3=0xdff0c4;
UWORD *Period3=0xdff0c6;
UWORD *Volume3=0xdff0c8;

ULONG *Adresse4=0xdff0d0;
UWORD *Laenge4=0xdff0d4;
UWORD *Period4=0xdff0d6;
UWORD *Volume4=0xdff0d8;

long Dummy;

UWORD Note1,Note2,Note3,Note4;
UWORD Instrument1,Instrument2,Instrument3,Instrument4;

int Laenge[17];
int Volume[17];
short Loop[17];

short Pattern[40];

UWORD *Start[15];

int Notepointer=0,Endpointer;
short Position=0; 

short Loop1,Loop2,Loop3,Loop4;

short counter2=0;

UWORD PatternAnz;
/**********************************************************************/

unsigned char *taste=0xbfec01;
short *Maus=0xdff00a;
short *Col=0xdff180;
short *HoleCol=0xdff1be;
short *DMAConr=0xdff002;
unsigned char *Mtaste=0xbfe001;
UWORD ad2, ad1;

struct Player {
	char name[30];
	long Zeit;
	int Level;
	int Lives; };

struct Players {
	struct Player Heino[4];
	};

struct Players *Player;

UWORD Colors[]=	{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };

UWORD Colors3[13][13]={
{ 0,0,0,0,0,0,0,0,0,0,0,0,0 },
{ 0,0,0,0,0,0,0,0,0,0,0,0,0 },
{ 0,0,0,0,0,0,0,0,0,0,0,0,0 },
{ 0,0,0,0,0,0,0,0,0,0,0,0,0 },
{ 0,0,0,0,0,0,0,0,0,0,0,0,0 },
{ 0,0,0,0,0,0,0,0,0,0,0,0,0 },
{ 0,0,0,0,0,0,0,0,0,0,0,0,0 },
{ 0,0,0,0,0,0,0,0,0,0,0,0,0 },
{ 0,0,0,0,0,0,0,0,0,0,0,0,0 },
{ 0,0,0,0,0,0,0,0,0,0,0,0,0 },
{ 0,0,0,0,0,0,0,0,0,0,0,0,0 },
{ 0,0,0,0,0,0,0,0,0,0,0,0,0 },
{ 0,0,0,0,0,0,0,0,0,0,0,0,0 } };

UWORD Bauka1Color[]={
        0xdaf, 
        0xc9e,
        0xb8d,
        0xa7c,
        0x96b,
        0x85a,
        0x749,
        0x638,
        0x527,
        0x416,
        0x315,
        0x214,
        0x214,
        0x214,
        0x103 };

/*UWORD Bauka3Color[]={
	0xf6b,
	0xe5a,
	0xd49,
	0xc38,
	0xa26,
	0x926,
	0x815,
	0x714,
	0x603,
	0x502,
	0x401,
	0x301,
	0x301,
	0x301,
	0x300 };*/

UWORD Bauka3Color[]={
	0xfb6,
	0xea5,
	0xd94,
	0xc83,
	0xa72,
	0x962,
	0x851,
	0x741,
	0x640,
	0x530,
	0x420,
	0x310,
	0x310,
	0x310,
	0x310 };

/*UWORD Bauka3Color2[13][13]={
{ 0x714, 0x714, 0x714, 0x714, 0x714, 0x714, 0x714, 0x714, 0x714, 0x714, 0x714, 0x714, 0x714 },
{ 0x714, 0x815, 0x815, 0x815, 0x815, 0x815, 0x815, 0x815, 0x815, 0x815, 0x815, 0x815, 0x714 },
{ 0x714, 0x815, 0x926, 0x926, 0x926, 0x926, 0x926, 0x926, 0x926, 0x926, 0x926, 0x815, 0x714 },
{ 0x714, 0x815, 0x926, 0xa26, 0xa26, 0xa26, 0xa26, 0xa26, 0xa26, 0xa26, 0x926, 0x815, 0x714 },
{ 0x714, 0x815, 0x926, 0xa26, 0xc38, 0xc38, 0xc38, 0xc38, 0xc38, 0xa26, 0x926, 0x815, 0x714 },
{ 0x714, 0x815, 0x926, 0xa26, 0xc38, 0xd49, 0xd49, 0xd49, 0xc38, 0xa26, 0x926, 0x815, 0x714 },
{ 0x714, 0x815, 0x926, 0xa26, 0xc38, 0xd49, 0xd49, 0xd49, 0xc38, 0xa26, 0x926, 0x815, 0x714 },
{ 0x714, 0x815, 0x926, 0xa26, 0xc38, 0xd49, 0xd49, 0xd49, 0xc38, 0xa26, 0x926, 0x815, 0x714 },
{ 0x714, 0x815, 0x926, 0xa26, 0xc38, 0xc38, 0xc38, 0xc38, 0xc38, 0xa26, 0x926, 0x815, 0x714 },
{ 0x714, 0x815, 0x926, 0xa26, 0xa26, 0xa26, 0xa26, 0xa26, 0xa26, 0xa26, 0x926, 0x815, 0x714 },
{ 0x714, 0x815, 0x926, 0x926, 0x926, 0x926, 0x926, 0x926, 0x926, 0x926, 0x926, 0x815, 0x714 },
{ 0x714, 0x815, 0x815, 0x815, 0x815, 0x815, 0x815, 0x815, 0x815, 0x815, 0x815, 0x815, 0x714 },
{ 0x714, 0x714, 0x714, 0x714, 0x714, 0x714, 0x714, 0x714, 0x714, 0x714, 0x714, 0x714, 0x714 } };
*/

UWORD Bauka3Color2[13][13]={
{ 0x741, 0x741, 0x741, 0x741, 0x741, 0x741, 0x741, 0x741, 0x741, 0x741, 0x741, 0x741, 0x741 },
{ 0x741, 0x851, 0x851, 0x851, 0x851, 0x851, 0x851, 0x851, 0x851, 0x851, 0x851, 0x851, 0x741 },
{ 0x741, 0x851, 0x962, 0x962, 0x962, 0x962, 0x962, 0x962, 0x962, 0x962, 0x962, 0x851, 0x741 },
{ 0x741, 0x851, 0x962, 0xa72, 0xa72, 0xa72, 0xa72, 0xa72, 0xa72, 0xa72, 0x962, 0x851, 0x741 },
{ 0x741, 0x851, 0x962, 0xa72, 0xc83, 0xc83, 0xc83, 0xc83, 0xc83, 0xa72, 0x962, 0x851, 0x741 },
{ 0x741, 0x851, 0x962, 0xa72, 0xc83, 0xd94, 0xd94, 0xd94, 0xc83, 0xa72, 0x962, 0x851, 0x741 },
{ 0x741, 0x851, 0x962, 0xa72, 0xc83, 0xd94, 0xd94, 0xd94, 0xc83, 0xa72, 0x962, 0x851, 0x741 },
{ 0x741, 0x851, 0x962, 0xa72, 0xc83, 0xd94, 0xd94, 0xd94, 0xc83, 0xa72, 0x962, 0x851, 0x741 },
{ 0x741, 0x851, 0x962, 0xa72, 0xc83, 0xc83, 0xc83, 0xc83, 0xc83, 0xa72, 0x962, 0x851, 0x741 },
{ 0x741, 0x851, 0x962, 0xa72, 0xa72, 0xa72, 0xa72, 0xa72, 0xa72, 0xa72, 0x962, 0x851, 0x741 },
{ 0x741, 0x851, 0x962, 0x962, 0x962, 0x962, 0x962, 0x962, 0x962, 0x962, 0x962, 0x851, 0x741 },
{ 0x741, 0x851, 0x851, 0x851, 0x851, 0x851, 0x851, 0x851, 0x851, 0x851, 0x851, 0x851, 0x741 },
{ 0x741, 0x741, 0x741, 0x741, 0x741, 0x741, 0x741, 0x741, 0x741, 0x741, 0x741, 0x741, 0x741 } };

UWORD Bauka1Color2[13][13]={
{ 0x527, 0x527, 0x527, 0x527, 0x527, 0x527, 0x527, 0x527, 0x527, 0x527, 0x527, 0x527, 0x527 },
{ 0x527, 0x638, 0x638, 0x638, 0x638, 0x638, 0x638, 0x638, 0x638, 0x638, 0x638, 0x638, 0x527 },
{ 0x527, 0x638, 0x749, 0x749, 0x749, 0x749, 0x749, 0x749, 0x749, 0x749, 0x749, 0x638, 0x527 },
{ 0x527, 0x638, 0x749, 0x85a, 0x85a, 0x85a, 0x85a, 0x85a, 0x85a, 0x85a, 0x749, 0x638, 0x527 },
{ 0x527, 0x638, 0x749, 0x85a, 0x96b, 0x96b, 0x96b, 0x96b, 0x96b, 0x85a, 0x749, 0x638, 0x527 },
{ 0x527, 0x638, 0x749, 0x85a, 0x96b, 0xa7c, 0xa7c, 0xa7c, 0x96b, 0x85a, 0x749, 0x638, 0x527 },
{ 0x527, 0x638, 0x749, 0x85a, 0x96b, 0xa7c, 0xb8d, 0xa7c, 0x96b, 0x85a, 0x749, 0x638, 0x527 },
{ 0x527, 0x638, 0x749, 0x85a, 0x96b, 0xa7c, 0xa7c, 0xa7c, 0x96b, 0x85a, 0x749, 0x638, 0x527 },
{ 0x527, 0x638, 0x749, 0x85a, 0x96b, 0x96b, 0x96b, 0x96b, 0x96b, 0x85a, 0x749, 0x638, 0x527 },
{ 0x527, 0x638, 0x749, 0x85a, 0x85a, 0x85a, 0x85a, 0x85a, 0x85a, 0x85a, 0x749, 0x638, 0x527 },
{ 0x527, 0x638, 0x749, 0x749, 0x749, 0x749, 0x749, 0x749, 0x749, 0x749, 0x749, 0x638, 0x527 },
{ 0x527, 0x638, 0x638, 0x638, 0x638, 0x638, 0x638, 0x638, 0x638, 0x638, 0x638, 0x638, 0x527 },
{ 0x527, 0x527, 0x527, 0x527, 0x527, 0x527, 0x527, 0x527, 0x527, 0x527, 0x527, 0x527, 0x527 } };
 	
WORD Wakelpattern[]={
	5,-5,5,-5,5,-5,5,-5,5,-5,4,-4,4,-4,4,-4,4,-4,4,-4,4,-4,4,-4,
	3,-3,3,-3,3,-3,3,-3,3,-3,3,-3,3,-3,3,-3,3,-3,3,-3,2,-2,
        2,-2,2,-2,2,-2,2,-2,2,-2,2,-2,2,-2,2,-2,2,-2,2,-2,
	1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,
	0,0,0,0,0,0,0,0,0 };

WORD Wabbelpattern[]={
	0x0044, 0x0000, 0x0044, 0x0000, 0x0044, 0x0000, 0x0033, 0x0000,
	0x0033, 0x0000, 0x0033, 0x0000, 0x0033, 0x0000, 0x0033, 0x0000,
	0x0033, 0x0000, 0x0033, 0x0000, 0x0033, 0x0000, 0x0033, 0x0000,
	0x0022, 0x0000,	0x0022, 0x0000,	0x0022, 0x0000,	0x0022, 0x0000,	
	0x0022, 0x0000,	0x0022, 0x0000,	0x0022, 0x0000,	0x0022, 0x0000,	
	0x0022, 0x0000,	0x0022, 0x0000,	0x0022, 0x0000,	0x0022, 0x0000,	
	0x0011, 0x0000, 0x0011, 0x0000, 0x0011, 0x0000, 0x0011, 0x0000, 
	0x0011, 0x0000, 0x0011, 0x0000, 0x0011, 0x0000, 0x0011, 0x0000, 
	0x0011, 0x0000, 0x0011, 0x0000, 0x0011, 0x0000, 0x0011, 0x0000, 
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };

UWORD TeileInfo[]={
	0,0,0,0,0,0,0,0,0,0,	0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,	0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,	0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,	0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,	0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,	0,0,0,0,0,0,0,0,0,0 };

UWORD Bauka1TeileInfo[]={
        0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,2,3,3,2,2,2,2,2,
        2,2,2,4,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
        1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,0,1,1,1,1 };

UWORD Bauka3TeileInfo[]={
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	4,4,4,4,4,4,4,4,4,4,4,4,
	3,3,3,2,2,2,2,2,2,2,2,2,2,2,0 };
        
UWORD *KugelShadow;

struct BitMap HitMap;
struct BitMap ExtraHitMap;
struct BitMap ShadowMap;
struct BitMap ShadowSourceMap;
struct BitMap Playfield;
struct BitMap BaukaMap;
struct BitMap TextMap;

struct RastPort rp1;
struct RastPort rp2;
struct RastPort rp;

UWORD Titlecopl[]= {
 0x0120,0x0000, /* Sprite 0  1. Pointer (high 3 bits) */ 
 0x0122,0x0000, /* Sprite 0  2. Pointer (low 15 bits) */
 0x0124,0x0000, /* Sprite 1  1. Pointer (high 3 bits) */ 
 0x0126,0x0000, /* Sprite 1  2. Pointer (low 15 bits) */
 0x0128,0x0000, /* Sprite 2  1. Pointer (high 3 bits) */ 
 0x012a,0x0000, /* Sprite 2  2. Pointer (low 15 bits) */
 0x012c,0x0000, /* Sprite 3  1. Pointer (high 3 bits) */ 
 0x012e,0x0000, /* Sprite 3  2. Pointer (low 15 bits) */
 0x0130,0x0000, /* Sprite 4  1. Pointer (high 3 bits) */ 
 0x0132,0x0000, /* Sprite 4  2. Pointer (low 15 bits) */
 0x0134,0x0000, /* Sprite 5  1. Pointer (high 3 bits) */ 
 0x0136,0x0000, /* Sprite 5  2. Pointer (low 15 bits) */
 0x0138,0x0000, /* Sprite 6  1. Pointer (high 3 bits) */ 
 0x013a,0x0000, /* Sprite 6  2. Pointer (low 15 bits) */
 0x013c,0x0000, /* Sprite 7  1. Pointer (high 3 bits) */ 
 0x013e,0x0000, /* Sprite 7  2. Pointer (low 15 bits) */
 0x008E,0x2981, /*  Display Window VSTART,HSTART            */
 0x0090,0x29C1, /*  Display Window VSTOP,HSTOP              */
 0x0092,0x0038, /*  Display Data fetch Start LOW RES        */
 0x0094,0x00D0, /*  Display Data fetch Stop                 */
 0x0102,0x0000, /*  No PlayField scroll                     */
 0x0104,0x0024, /*  All Sprites in front of both PlayFields */
 0x0108,0x00a0, /*  BitPlane Modulo odd Planes              */
 0x010A,0x00a0, /*  BitPlane Modulo even Planes             */
 0x00E0,0x0000, /*  Plane 1 Pointer (high 3 bits)           */
 0x00E2,0x0000, /*  Plane 1 Pointer (low 15 bits)           */
 0x00E4,0x0000, /*  Plane 2                                 */
 0x00E6,0x0000,
 0x00E8,0x0000, /*  Plane 3                                 */
 0x00EA,0x0000,
 0x00EC,0x0000, /*  Plane 4                                 */
 0x00EE,0x0000,
 0x00F0,0x0000, /*  Plane 5                                 */
 0x00F2,0x0000, 
 0x0100,0x5200, /* 5 BitPlanes, LOW RES, Color_ON           */
 0x0180,0x0000,
 0x0182,0x0fa0, 0x0184,0x0d90, 0x0186,0x0b70, 0x0188,0x0a70, 0x018a,0x0850,
 0x018c,0x0640, 0x018e,0x0430, 0x0190,0x0320, 0x0192,0x0aaa, 0x0194,0x0999,
 0x0196,0x0666, 0x0198,0x0bbb, 0x019a,0x0fff, 0x019c,0x0666, 0x019e,0x0f88,
 0x01a0,0x0d33, 0x01a2,0x0b00, 0x01a4,0x0800, 0x01a6,0x0f00, 0x01a8,0x0000,
 0x01aa,0x0800, 0x01ac,0x0f00, 0x01ae,0x0f90, 0x01b0,0x0ff0, 0x01b2,0x00aa,
 0x01b4,0x00bb, 0x01b6,0x00cc, 0x01b8,0x00dd, 0x01ba,0x00f0, 0x01bc,0x0333,
 0x01be,0x0fff,

 0x7b01,0xfffe, /* Fuer Wassercentury */
 0x0180,0x0003,
 0x0182,0x007f, 0x0184,0x006d, 0x0186,0x005b, 0x0188,0x005a, 0x018a,0x0048,
 0x018c,0x0036, 0x018e,0x0024, 0x0190,0x0023, 0x0192,0x005a, 0x0194,0x0049,
 0x0196,0x0036, 0x0198,0x005b, 0x019a,0x0fff, 0x019c,0x0026, 0x019e,0x0a2a,
 0x01a0,0x0919, 0x01a2,0x0818, 0x01a4,0x0707, 0x01a6,0x0404, 0x01a8,0x0000,
 0x01be,0x019f,

 0x0102,0x0000,   /* 181 */
 0x7e01,0xfffe,   /* Fuer Wasserimitation  */
 0x0180,0x0004,
 0x0102,0x0000,   /* +6  */ 
 0x7f01,0xfffe, 
 0x0180,0x0004,
 0x0102,0x0000, 
 0x8001,0xfffe, 
 0x0180,0x0004,
 0x0102,0x0000, 
 0x8101,0xfffe,
 0x0180,0x0005,
 0x0102,0x0000,
 0x8201,0xfffe,
 0x0180,0x0005,
 0x0102,0x0000,
 0x8301,0xfffe,
 0x0180,0x0005,
 0x0102,0x0000,
 0x8401,0xfffe,
 0x0180,0x0006,
 0x0102,0x0000,
 0x8501,0xfffe,
 0x0180,0x0006,
 0x0102,0x0000,
 0x8601,0xfffe,
 0x0180,0x0006,
 0x0102,0x0000,
 0x8701,0xfffe,
 0x0180,0x0007,
 0x0102,0x0000,
 0x8801,0xfffe,
 0x0180,0x0007,
 0x0102,0x0000,
 0x8901,0xfffe,
 0x0180,0x0007,
 0x0102,0x0000,
 0x8a01,0xfffe,
 0x0180,0x0008,
 0x0102,0x0000,
 0x8b01,0xfffe,
 0x0180,0x0008,
 0x0102,0x0000,
 0x8c01,0xfffe,
 0x0180,0x0008,
 0x0102,0x0000,
 0x8d01,0xfffe,
 0x0180,0x0009,
 0x0102,0x0000,
 0x8e01,0xfffe,
 0x0180,0x0009,
 0x0102,0x0000,
 0x8f01,0xfffe,
 0x0180,0x0009,
 0x0102,0x0000,
 0x9001,0xfffe,
 0x0180,0x000a,
 0x0102,0x0000,
 0x9101,0xfffe,
 0x0180,0x000a,
 0x0102,0x0000,
 0x9201,0xfffe,
 0x0180,0x000a,
 0x0102,0x0000,
 0x9301,0xfffe,
 0x0180,0x000b,
 0x0102,0x0000,
 0x9401,0xfffe,
 0x0180,0x000b,
 0x0102,0x0000,
 0x9501,0xfffe,
 0x0180,0x000b,
 0x0102,0x0000,
 0x9601,0xfffe,
 0x0180,0x000c,
 0x0102,0x0000,
 0x9701,0xfffe,
 0x0180,0x000c,
 0x0102,0x0000,
 0x9801,0xfffe,
 0x0180,0x000c,
 0x0102,0x0000,
 0x9901,0xfffe,
 0x0180,0x000d,
 0x0102,0x0000,
 0x9a01,0xfffe,
 0x0180,0x000d,
 0x0102,0x0000,
 0x9b01,0xfffe,
 0x0180,0x000d,
 0x0102,0x0000,
 0x9c01,0xfffe,
 0x0180,0x000e,
 0x0102,0x0000,
 0x9d01,0xfffe,
 0x0180,0x000e,
 0x0102,0x0000,
 0x9e01,0xfffe,
 0x0180,0x000e,
 0x0102,0x0000,
 0x9f01,0xfffe,
 0x0180,0x000f,
 0x0102,0x0000,
 0xa001,0xfffe,
 0x0180,0x000f,
 0x0102,0x0000,
 0xa101,0xfffe,
 0x0180,0x000f,
 0x0102,0x0000, /* 397 */

 0xa601,0xfffe, /* Fuer Restlichen Text */
 0x0102,0x0000,
 
 0x0182,0x0f00, 0x0184,0x0d00, 0x0186,0x0b00, 0x0188,0x0a00, 0x018a,0x0800,
 0x018c,0x0600, 0x018e,0x0400, 0x0190,0x0300, 0x0192,0x005a, 0x0194,0x0049,
 0x01ba,0x0000,

 0xea01,0xfffe,
 0x0182,0x0f0f,
 0x0186,0x0000,
 0xeb01,0xfffe,
 0x0182,0x0e0e,
 0xec01,0xfffe,
 0x0182,0x0d0d,
 0xed01,0xfffe,
 0x0182,0x0c0c,
 0xee01,0xfffe,
 0x0182,0x0b0b,
 0xef01,0xfffe,
 0x0182,0x0a0a,
 0xf001,0xfffe,
 0x0182,0x0909,
 0xf101,0xfffe,
 0x0182,0x0808,

 0xff01,0xfffe,
 0x0100,0x0000,
 0xffff,0xfffe };


#asm
   public _colset
_colset:
   move.w #$000,$dff180
   move.w #$80f,$dff182
   move.w #$70d,$dff184
   move.w #$b6f,$dff186
   move.w #$95d,$dff188
   move.w #$70d,$dff18a
   move.w #$50a,$dff18c
   move.w #$50a,$dff18e
   move.w #$408,$dff190
   move.w #$408,$dff192
   move.w #$305,$dff194
   move.w #$50a,$dff196
   move.w #$408,$dff198
   move.w #$90f,$dff19a /**/
   move.w #$70c,$dff19c
   move.w #$b6d,$dff19e
   move.w #$95d,$dff1a0 /****** Sprite 0 ***/
   move.w #$daf,$dff1a2
   move.w #$b8d,$dff1a4
   move.w #$22c,$dff1a6
   move.w #$22a,$dff1a8
   move.w #$6ff,$dff1aa
   move.w #$4dd,$dff1ac
   move.w #$2bb,$dff1ae
   move.w #$099,$dff1b0
   move.w #$f44,$dff1b2
   move.w #$c00,$dff1b4
   move.w #$a00,$dff1b6
   move.w #$800,$dff1b8
   move.w #$600,$dff1ba
   move.w #$400,$dff1bc
   move.w #$000,$dff1be
   rts
#endasm

int MausAlt,MausNeu;
int MausX=0,MausY=0;

UWORD Blackcopl[]= {
	0x0180, 0x0000,
	0x0100, 0x0000,
	0xffff, 0xfffe };

UWORD copl[]= {
 0x0120,0x0000, /* Sprite 0  1. Pointer (high 3 bits) */ 
 0x0122,0x0000, /* Sprite 0  2. Pointer (low 15 bits) */
 0x0124,0x0000, /* Sprite 1  1. Pointer (high 3 bits) */ 
 0x0126,0x0000, /* Sprite 1  2. Pointer (low 15 bits) */
 0x0128,0x0000, /* Sprite 2  1. Pointer (high 3 bits) */ 
 0x012a,0x0000, /* Sprite 2  2. Pointer (low 15 bits) */
 0x012c,0x0000, /* Sprite 3  1. Pointer (high 3 bits) */ 
 0x012e,0x0000, /* Sprite 3  2. Pointer (low 15 bits) */
 0x0130,0x0000, /* Sprite 4  1. Pointer (high 3 bits) */ 
 0x0132,0x0000, /* Sprite 4  2. Pointer (low 15 bits) */
 0x0134,0x0000, /* Sprite 5  1. Pointer (high 3 bits) */ 
 0x0136,0x0000, /* Sprite 5  2. Pointer (low 15 bits) */
 0x0138,0x0000, /* Sprite 6  1. Pointer (high 3 bits) */ 
 0x013a,0x0000, /* Sprite 6  2. Pointer (low 15 bits) */
 0x013c,0x0000, /* Sprite 7  1. Pointer (high 3 bits) */ 
 0x013e,0x0000, /* Sprite 7  2. Pointer (low 15 bits) */
 0x008E,0x2981, /*  Display Window VSTART,HSTART            */
 0x0090,0x29C1, /*  Display Window VSTOP,HSTOP              */
 0x0092,0x0038, /*  Display Data fetch Start LOW RES        */
 0x0094,0x00D0, /*  Display Data fetch Stop                 */
 0x0102,0x0000, /*  No PlayField scroll                     */
 0x0104,0x0024, /*  All Sprites in front of both PlayFields */
 0x0108,0x00E0, /*  BitPlane Modulo odd Planes              */
 0x010A,0x00E0, /*  BitPlane Modulo even Planes             */
 0x00E0,0x0000, /*  Plane 1 Pointer (high 3 bits)           */
 0x00E2,0x0000, /*  Plane 1 Pointer (low 15 bits)           */
 0x00E4,0x0000, /*  Plane 2                                 */
 0x00E6,0x0000,
 0x00E8,0x0000, /*  Plane 3                                 */
 0x00EA,0x0000,
 0x00EC,0x0000, /*  Plane 4                                 */
 0x00EE,0x0000,
 0x00F0,0x0000, /*  Plane 5                                 */
 0x00F2,0x0000,
 0x00F4,0x0000, /*  Plane 6                                 */
 0x00F6,0x0000,
 0x0102,0x0000, /* ???????????????????????????????????????  */
 0x0182,0x0000, 0x0184,0x0000, 0x0186,0x0000, 0x0188,0x0000, 0x018a,0x0000,
 0x018c,0x0000, 0x018e,0x0000, 0x0190,0x0000, 0x0192,0x0000, 0x0194,0x0000,
 0x0196,0x0000, 0x0198,0x0000, 0x019a,0x0000, 0x019c,0x0000, 0x019e,0x0000,
 0x01a0,0x0000, 0x01a2,0x0000, 0x01a4,0x0000,

 0xff01,0xfffe,
 0x0100,0x6200, /* 6 BitPlanes, LOW RES, Color_ON, ! EHB !  */
 0xff01,0xfffe,
 0x0100,0x0000,
 0xffff,0xfffe };

WORD a1,a2,b1,b2;
UWORD *Pieps;

#asm
    public  _ICop
_ICop:
   move.l      #_copl,$dff080
   clr.w      $dff088
   rts
    public  _TitleCop
_TitleCop:
   move.l      #_Titlecopl,$dff080
   clr.w      $dff088
   rts
    public  _Black
_Black:
   move.l      #_Blackcopl,$dff080
   clr.w      $dff088
   rts
#endasm

UWORD Wabber2[]={ 0x00, 0x11, 0x22, 0x33 };

WORD Huepf[]={ 0,0,1,1,1,1,2,2,2,2,2,2,2,3,3,3,3,3,3,-1 };

UWORD *Baukaplane;
UWORD *Shadowplane;
UWORD *S_shadowplane;
UWORD *Shadowsourceplane;
UWORD *plane1;
UWORD *planewakel;
UWORD *S_plane1;
UWORD *saveplane;
UWORD *Testplane;
UWORD *ExtraTestplane;
UWORD *KugelCheck;
UBYTE *KugelImages;
UBYTE *KugelImages2;
UBYTE *KugelFall;
UBYTE *Bohnen;
UWORD *Textplane;
UWORD *src;
UWORD *dest;
UWORD *Absturz;
UWORD *Rumpel;
UWORD *Gummi1;
UWORD *Metal1;
UWORD *Metal2;
UWORD *Holz1;
UWORD *Holz2;
UWORD *Glas1;
UWORD *Glas2;
UWORD *Einsammel;
UWORD *Sounds;

UBYTE *KSprites[9][9];
UBYTE *KFall[8];

struct GfxBase *GfxBase;
struct IntuitionBase *IntuitionBase;

WORD sinus[] = 
 {
  0x0000, 0x023C, 0x0478, 0x06B3, 0x08EE, /*  0- 4 Grad */
  0x0B28, 0x0D61, 0x0F99, 0x11D0, 0x1406, /*  5- 9 Grad */
  0x163A, 0x186C, 0x1A9D, 0x1CCB, 0x1EF7, /* 10-14 Grad */
  0x2121, 0x2348, 0x256C, 0x278E, 0x29AC, /* ...        */
  0x2BC7, 0x2DDF, 0x2FF3, 0x3203, 0x3410,
  0x3618, 0x381D, 0x3A1C, 0x3C18, 0x3E0E,
  0x4000, 0x41ED, 0x43D4, 0x45B7, 0x4794,
  0x496B, 0x4B3D, 0x4D08, 0x4ECE, 0x508E,
  0x5247, 0x53FA, 0x55A6, 0x574C, 0x58EB,
  0x5A82, 0x5C13, 0x5D9D, 0x5F1F, 0x609A,
  0x620E, 0x637A, 0x64DE, 0x663A, 0x678E,
  0x68DA, 0x6A1E, 0x6B5A, 0x6C8D, 0x6DB8,
  0x6EDA, 0x6FF4, 0x7104, 0x720D, 0x730C,
  0x7402, 0x74EF, 0x75D3, 0x76AE, 0x7780,
  0x7848, 0x7907, 0x79BC, 0x7A68, 0x7B0B,
  0x7BA3, 0x7C33, 0x7CB8, 0x7D34, 0x7DA6,
  0x7E0E, 0x7E6D, 0x7EC1, 0x7F0C, 0x7F4C,
  0x7F83, 0x7FB0, 0x7FD3, 0x7FEC, 0x7FFB,

  0x7FFF, 0x7FFB, 0x7FEC, 0x7FD3, 0x7FB0, /* 90-94 Grad */
  0x7F83, 0x7F4C, 0x7F0C, 0x7EC1, 0x7E6D, /* 95-99 Grad */
  0x7E0E, 0x7DA6, 0x7D34, 0x7CB8, 0x7C33, /* ...        */
  0x7BA3, 0x7B0B, 0x7A68, 0x79BC, 0x7907,
  0x7848, 0x7780, 0x76AE, 0x75D3, 0x74EF,
  0x7402, 0x730C, 0x720D, 0x7104, 0x6FF4,
  0x6EDA, 0x6DB8, 0x6C8D, 0x6B5A, 0x6A1E,
  0x68DA, 0x678E, 0x663A, 0x64DE, 0x637A,
  0x620E, 0x609A, 0x5F1F, 0x5D9D, 0x5C13,
  0x5A82, 0x58EB, 0x574C, 0x55A6, 0x53FA,
  0x5247, 0x508E, 0x4ECE, 0x4D08, 0x4B3D,
  0x496B, 0x4794, 0x45B7, 0x43D4, 0x41ED,
  0x4000, 0x3E0E, 0x3C18, 0x3A1C, 0x381D,
  0x3618, 0x3410, 0x3203, 0x2FF3, 0x2DDF,
  0x2BC7, 0x29AC, 0x278E, 0x256C, 0x2348,
  0x2121, 0x1EF7, 0x1CCB, 0x1A9D, 0x186C,
  0x163A, 0x1406, 0x11D0, 0x0F99, 0x0D61,
  0x0B28, 0x08EE, 0x06B3, 0x0478, 0x023C,

  0x0000, 0xFDC4, 0xFB88, 0xF94D, 0xF712, /* 180-184 Grad */
  0xF4D8, 0xF29F, 0xF067, 0xEE30, 0xEBFA, /* ...          */
  0xE9C6, 0xE794, 0xE563, 0xE335, 0xE109,
  0xDEDF, 0xDCB8, 0xDA94, 0xD872, 0xD654,
  0xD439, 0xD221, 0xD00D, 0xCDFD, 0xCBF0,
  0xC9E8, 0xC7E3, 0xC5E4, 0xC3E8, 0xC1F2,
  0xC000, 0xBE13, 0xBC2C, 0xBA49, 0xB86C,
  0xB695, 0xB4C3, 0xB2F8, 0xB132, 0xAF72,
  0xADB9, 0xAC06, 0xAA5A, 0xA8B4, 0xA715,
  0xA57E, 0xA3ED, 0xA263, 0xA0E1, 0x9F66,
  0x9DF2, 0x9C86, 0x9B22, 0x99C6, 0x9872,
  0x9726, 0x95E2, 0x94A6, 0x9373, 0x9248,
  0x9126, 0x900C, 0x8EFC, 0x8DF3, 0x8CF4,
  0x8BFE, 0x8B11, 0x8A2D, 0x8952, 0x8880,
  0x87B8, 0x86F9, 0x8644, 0x8598, 0x84F5,
  0x845D, 0x83CD, 0x8348, 0x82CC, 0x825A,
  0x81F2, 0x8193, 0x813F, 0x80F4, 0x80B4,
  0x807D, 0x8050, 0x802D, 0x8014, 0x8005,

  0x8000, 0x8005, 0x8014, 0x802D, 0x8050, /* 270-274 Grad */
  0x807D, 0x80B4, 0x80F4, 0x813F, 0x8193, /* ...          */
  0x81F2, 0x825A, 0x82CC, 0x8348, 0x83CD,
  0x845D, 0x84F5, 0x8598, 0x8644, 0x86F9,
  0x87B8, 0x8880, 0x8952, 0x8A2D, 0x8B11,
  0x8BFE, 0x8CF4, 0x8DF3, 0x8EFC, 0x900C,
  0x9126, 0x9248, 0x9373, 0x94A6, 0x95E2,
  0x9726, 0x9872, 0x99C6, 0x9B22, 0x9C86,
  0x9DF2, 0x9F66, 0xA0E1, 0xA263, 0xA3ED,
  0xA57E, 0xA715, 0xA8B4, 0xAA5A, 0xAC06,
  0xADB9, 0xAF72, 0xB132, 0xB2F8, 0xB4C3,
  0xB695, 0xB86C, 0xBA49, 0xBC2C, 0xBE13,
  0xC000, 0xC1F2, 0xC3E8, 0xC5E4, 0xC7E3,
  0xC9E8, 0xCBF0, 0xCDFD, 0xD00D, 0xD221,
  0xD439, 0xD654, 0xD872, 0xDA94, 0xDCB8,
  0xDEDF, 0xE109, 0xE335, 0xE563, 0xE794,
  0xE9C6, 0xEBFA, 0xEE30, 0xF067, 0xF29F,
  0xF4D8, 0xF712, 0xF94D, 0xFB88, 0xFDC4  /* 355-359 Grad */
 };

UWORD LeerSpr[]={ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000 };

extern void *AllocRaster(), *AllocMem();
int HowMany,NewGame=1,Plaier=10,Level=0,Key=0,Steuerung=0;
int x1,y1,KugelTyp,en=1;
int x1p8,y1p8,Fin_Count[10],T_Seconds=0,T_Count=0,Plaierbefore=1,SteuerTime;
int i=160,j=100,xk,yk,WinkelFlaecheY,WinkelFlaecheX,WinkelBodenY,WinkelBodenX;
short Hertz=0, HalfFrame=0, Hertz2=0, HalfFrame2=0, Choice,StartNew=0, Runte, Livesight=0;
int WinkelX,WinkelY,NeuWy=0,dx,dy,ShowTime=0,ShadowOldX=0,ShadowOldY=0;
int screen=0,xx=0,p=0,x2=0,y2=0,pen,x3,y3,Test,NeuWx=0,xalt,yalt,Mo_X,Mo_Y;
float ax,gx,vx=0.0,sx=0.0,ay,gy,vy=0.0,sy=0.0,k,m,sxalt,syalt;
float Prall=-0.55,SCHWERKRAFT=9.81,KugelSX,KugelSY,surex,surey;
int BallY,Direction,Num,BallY2,Direction2,Num2,Buchstabe=0,count3=0,qi=0;
short s_1=0,s_2=0,s_3=0,s_4=0,s_5=0,s_6=0,s_7=0,s_8=0,soundx=0,soundy=0,Volime=0,zuf;
char FreiSpei[10], *SText;
long Memory;
short Senfo=0,Busy=0,s_9=0,BaukaTyp=1, altv,TheFirstTime=1,Hole,Holecount;
short Darkness=0, OutCount,KugelAus=0,PlayerON[4],GameOver=0,LastBauka=1;
short Richtung, Stand, ThirtyOne=0, LevNum=-1, NotSure=0;
UWORD CollWert;

/***************** HAUPTPROGRAMM *************************************/
main()
{
  LONG File,Length;
  register int zz,i,j;

  GfxBase = (struct GfxBase*)OpenLibrary("graphics.library",0L); 
  IntuitionBase=(struct IntuitionBase*)OpenLibrary("intuition.library",0L); 
  OpenDev(); 

   CloseWindow(IntuitionBase->ActiveWindow);
   CloseWorkBench();

Black();
        Player=AllocMem((sizeof(struct Players)),MEMF_CHIP|MEMF_CLEAR);
	SText=AllocMem(2000,MEMF_CHIP|MEMF_CLEAR);

InitRastPort(&rp);
InitRastPort(&rp1);
InitRastPort(&rp2);

        KugelCheck=AllocMem(1000,MEMF_CHIP|MEMF_CLEAR);
        KugelShadow=AllocMem(1000,MEMF_CHIP|MEMF_CLEAR);

   InitBitMap(&BaukaMap,1L,320L,1400L); /** 48000 **/
        BaukaMap.Planes[0] = (PLANEPTR)AllocRaster(320L,1400L);
#asm
        move.l d0,_Baukaplane
#endasm
        BltClear(BaukaMap.Planes[0], RASSIZE(320L,1400L), 1L);

   InitBitMap(&HitMap,1L,320L,220L);    /** 8800 **/
        HitMap.Planes[0] = (PLANEPTR)AllocRaster(320L,220L);
#asm
        move.l d0,_Testplane
#endasm
        BltClear(HitMap.Planes[0], RASSIZE(320L,220L), 1L);

   InitBitMap(&ExtraHitMap,1L,320L,220L);    /** 8800 **/
        ExtraHitMap.Planes[0] = (PLANEPTR)AllocRaster(320L,220L);
#asm
        move.l d0,_ExtraTestplane
#endasm
        BltClear(ExtraHitMap.Planes[0], RASSIZE(320L,220L), 1L);

   InitBitMap(&ShadowMap,1L,336L,220L);   /** 9240 **/
        ShadowMap.Planes[0] = (PLANEPTR)AllocRaster(336L,220L);
#asm
        move.l d0,_Shadowplane
#endasm
        BltClear(ShadowMap.Planes[0], RASSIZE(336L,220L), 1L);

   InitBitMap(&ShadowSourceMap,1L,320L,230L);  /** 8000 **/
        ShadowSourceMap.Planes[0] = (PLANEPTR)AllocRaster(320L,230L);
#asm
        move.l d0,_Shadowsourceplane
#endasm
        BltClear(ShadowSourceMap.Planes[0], RASSIZE(320L,230L), 1L);

   InitBitMap(&Playfield,1,352,1440);   /** 67936 **/
        Playfield.Planes[0] = (PLANEPTR)AllocRaster(352L,1440L);
#asm
        move.l d0,_plane1
#endasm
        BltClear(Playfield.Planes[0], RASSIZE(352,1440), 1L);

   InitBitMap(&TextMap,1,320,1962);   
        TextMap.Planes[0] = (PLANEPTR)AllocRaster(320L,1962);
#asm
        move.l d0,_Textplane
#endasm
        BltClear(TextMap.Planes[0], RASSIZE(320,1962), 1L);

rp.BitMap=&TextMap;

S_plane1=plane1;
S_shadowplane=Shadowplane;

ReadIn(KugelCheck,"df0:Kugeltest.cru"); 
ReadIn(KugelShadow,"df0:KugelShadow.cru"); 

Pieps=AllocMem(1000L,MEMF_CHIP|MEMF_CLEAR);
KugelImages=AllocMem(12000,MEMF_CHIP);
KugelImages2=AllocMem(12000,MEMF_CHIP);
KugelFall=AllocMem(1500,MEMF_CHIP);
Bohnen=AllocMem(1000,MEMF_CHIP);

Sounds=AllocMem(51000,MEMF_CHIP|MEMF_CLEAR);
Load(KugelImages2,"df0:Kugel_Image2");
Load(KugelImages,"df0:Kugel_Images");

StoryBoard=AllocMem(sizeof(struct StoryBoard),MEMF_CHIP|MEMF_CLEAR);
Load(StoryBoard,"df0:StoryBoard");

Load(Sounds,"df0:Sounds.snd");
Einsammel=Sounds;
Absturz=Sounds+4426;
Rumpel=Sounds+11110;
Gummi1=Sounds+16195;
Holz1=Sounds+18268;
Holz2=Sounds+18933;
Glas1=Sounds+19305;
Glas2=Sounds+21178;
Metal1=Sounds+22948;
Metal2=Sounds+24481;

*(Einsammel)=0;
*(Einsammel+1)=0;
*(Absturz)=0;
*(Absturz+1)=0;
*(Rumpel)=0;
*(Rumpel+1)=0;
*(Gummi1)=0;
*(Gummi1+1)=0;
*(Holz1)=0;
*(Holz1+1)=0;
*(Holz2)=0;
*(Holz2+1)=0;
*(Glas1)=0;
*(Glas1+1)=0;
*(Glas2)=0;
*(Glas2+1)=0;
*(Metal1)=0;
*(Metal1+1)=0;
*(Metal2)=0;
*(Metal2+1)=0;

Load(Bohnen,"df0:Bohnen");
Load(KugelFall,"df0:Kugel_Fall");
Load(SText,"df0:Text");
Load(Pieps+2,"df0:Pieps");

   for(j=0; j<8; j++)
    	{
 	KFall[j]=(KugelFall+(j*144));
	}

for(i=0; i<9; i++)
   {
   for(j=0; j<9; j++)
    	{
 	KSprites[i][j]=(KugelImages+(i*1296)+(j*144));
	}
   }
   
#asm
   move.l _Baukaplane,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
Titlecopl[49]=a2;
Titlecopl[51]=a1;
#asm
   move.l _Baukaplane,d3
   add.l #40,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
Titlecopl[53]=a2;
Titlecopl[55]=a1;
#asm
   move.l _Baukaplane,d3
   add.l #80,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
Titlecopl[57]=a2;
Titlecopl[59]=a1;
#asm
   move.l _Baukaplane,d3
   add.l #120,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
Titlecopl[61]=a2;
Titlecopl[63]=a1;
#asm
   move.l _Baukaplane,d3
   add.l #160,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
Titlecopl[65]=a2;
Titlecopl[67]=a1;

        MotorOn();
	for(i=0; i<80; i++) SeekTrack(i,0,5);
	SeekTrack(0,0,3);
	for(i=0; i<80; i++) SeekTrack(i,0,5);
        MotorOff();

Forbid();

ShowTitle:

BltClear(BaukaMap.Planes[0], RASSIZE(320L,1306L), 1L);
BltClear(TextMap.Planes[0], RASSIZE(320,1962), 1L);
BltClear(Playfield.Planes[0], RASSIZE(352,1440), 1L);
Buchstabe=0; StartNew=0;
ReadIn(Baukaplane,"df0:Title.cru"); 
ReadIn(Shadowsourceplane,"df0:Font2.cru"); 
Track=AllocMem(sizeof(struct FuchsTracker),MEMF_CLEAR|MEMF_CHIP);

for(i=1; i<50; i++)
{
for(zz=181; zz<397; zz+=6) Titlecopl[zz]=Titlecopl[zz+6];	
Titlecopl[397]=Wabber2[qi];
qi++;
if(qi>=4) qi=0;
}

/*********************  Die Musi loadn loassn !! ************************/
Notepointer=0;
Position=0; 
counter2=0;

File=Open("df0:TitleTheme",MODE_OLDFILE);
Read(File,(struct FuchsTracker *)Track,sizeof(struct FuchsTracker));
Read(File,&Dummy,4);
Read(File,&Length,4);

Instruments=(Textplane+(Length/2));
Noten=Textplane;

Read(File,(UWORD *)Noten,Length);
Read(File,&Dummy,4);
Read(File,(UWORD *)Instruments,Track->AllInstrLength);
Close(File);

for(i=1; i<=16; i++)
        {        
        Start[i]=Instruments;
        *(Start[i])=0;
        *(Start[i]+1)=0;
        Instruments+=(Track->Laenge_Instr[i-1]/2);
        Laenge[i]=(Track->Laenge_Instr[i-1]/2);
        Volume[i]=Track->Volume[i-1];
        Loop[i]=Track->Loop[i-1];
        }

PatternAnz=Track->PatternAnz;

for(i=0; i<PatternAnz; i++) 
        {
        Pattern[i]=Track->Positions[i];
        }

   Notepointer=(Pattern[Position]*512);
   Endpointer=Notepointer+512;

/**********************************  TitlePic ****************************/

TitleCop();

BltBitMap(&BaukaMap,0,90,&Playfield,0,15,33,165,0xc0,0xff,0);
BltBitMap(&BaukaMap,0,485,&Playfield,33,10,33,85,0xc0,0xff,0);
BltBitMap(&Playfield,0,700,&BaukaMap,0,90,33,165,0xc0,0xff,0);
BltBitMap(&Playfield,0,700,&BaukaMap,287,90,33,165,0xc0,0xff,0);
BltBitMap(&Playfield,0,700,&BaukaMap,0,485,33,85,0xc0,0xff,0);
BltBitMap(&Playfield,0,700,&BaukaMap,287,485,33,85,0xc0,0xff,0);

Direction=DOWN;
Num=0;
BallY=7;

Direction2=UP;
Num2=18;
BallY2=43;

while(1)
	{
/*********************  Die Musi spuiln loassn !! ************************/
   if(counter2==0)
        {
        Note1=*(Noten+Notepointer);
        Instrument1=(*(Noten+Notepointer+1)>>12);
        Note2=*(Noten+Notepointer+2);
        Instrument2=(*(Noten+Notepointer+3)>>12);
        Note3=*(Noten+Notepointer+4);
        Instrument3=(*(Noten+Notepointer+5)>>12);
        Note4=*(Noten+Notepointer+6);
        Instrument4=(*(Noten+Notepointer+7)>>12);
        }
   if(counter2==1)
        {
        PlayMusik();
        }
   if(counter2==2)
        {
        if(Instrument1!=0)
                {
                Loop1=0;
                if(Loop[Instrument1]) Loop1=1;
                }
        if(Instrument2!=0)
                {
                Loop2=0;
                if(Loop[Instrument2]) Loop2=1;
                }
        if(Instrument3!=0)
                {
                Loop3=0;
                if(Loop[Instrument3]) Loop3=1;
                }
        if(Instrument4!=0)
                {
                Loop4=0;
                if(Loop[Instrument4]) Loop4=1;
                }
   if((*(Noten+Notepointer+1)&0x0c00)) *Volume1=(*(Noten+Notepointer+1)&0xff);
   if((*(Noten+Notepointer+3)&0x0c00)) *Volume2=(*(Noten+Notepointer+3)&0xff);
   if((*(Noten+Notepointer+5)&0x0c00)) *Volume3=(*(Noten+Notepointer+5)&0xff);
   if((*(Noten+Notepointer+7)&0x0c00)) *Volume4=(*(Noten+Notepointer+7)&0xff);
   if((*(Noten+Notepointer+1)&0x0f00)==0x0d00) Notepointer=Endpointer+1;
   if((*(Noten+Notepointer+3)&0x0f00)==0x0d00) Notepointer=Endpointer+1;
   if((*(Noten+Notepointer+5)&0x0f00)==0x0d00) Notepointer=Endpointer+1;
   if((*(Noten+Notepointer+7)&0x0f00)==0x0d00) Notepointer=Endpointer+1;
        }
   if(counter2==3)
        {
   if((*(Noten+Notepointer+1)&0x0f00)==0x0f00) Fast=(*(Noten+Notepointer+1)&0xf); 
   if((*(Noten+Notepointer+3)&0x0f00)==0x0f00) Fast=(*(Noten+Notepointer+3)&0xf); 
   if((*(Noten+Notepointer+5)&0x0f00)==0x0f00) Fast=(*(Noten+Notepointer+5)&0xf); 
   if((*(Noten+Notepointer+7)&0x0f00)==0x0f00) Fast=(*(Noten+Notepointer+7)&0xf); 
        Notepointer+=8;
        if(Notepointer>=Endpointer)
                {
                Position++;
                if(Position>PatternAnz) Position=0;
                Notepointer=(Pattern[Position]*512);
                Endpointer=Notepointer+512;
                }
        }
   if(counter2==4)
        {
        WaitSound();
        }
   counter2++;
   if(counter2>=Fast) counter2=0;	
/***********************************************************************/
	if(*taste==0x5f) { Choice=1; break; }
	if(*taste==0x5d) { Choice=2; break; }

if(*taste==0x57) *Col=0xf00;

	if(Direction==DOWN)
		{
		BallY+=Huepf[Num];
		Num++;
		if(Huepf[Num]==-1) { Direction=UP; Num--; }
		}
		else if(Direction==UP)
			{
			BallY-=Huepf[Num];
			Num--;
			if(Num==-1) { Direction=DOWN; Num=0; }
			}
	BltBitMap(&Playfield,0,0,&BaukaMap,0,BallY*5,33,195,0xc0,0xff,0);
	if(Direction2==DOWN)
		{
		BallY2+=Huepf[Num2];
		Num2++;
		if(Huepf[Num2]==-1) { Direction2=UP; Num2--; }
		}
		else if(Direction2==UP)
			{
			BallY2-=Huepf[Num2];
			Num2--;
			if(Num2==-1) { Direction2=DOWN; Num2=0; }
			}
	BltBitMap(&Playfield,0,0,&BaukaMap,287,BallY2*5,33,195,0xc0,0xff,0);

 BltBitMap(&Playfield,33,0,&BaukaMap,0,(103-(BallY>>1))*5,33,105,0xc0,0xff,0);
 BltBitMap(&Playfield,33,0,&BaukaMap,287,(103-(BallY2>>1))*5,33,105,0xc0,0xff,0);
 
/*******************    ScrollText    ************************************/

        BltBitMap(&Playfield,1,700,&Playfield,0,700,330,45,0xc0,0xff,0);

        if(count3==8) { FontPrint(*(SText+Buchstabe)); 	Buchstabe++; count3=0; }
	count3++;

	if(StartNew==1) { Buchstabe=0; StartNew=0; }
	BltBitMap(&Playfield,0,700,&BaukaMap,0,965,320,45,0xc0,0xff,0);

/********************  Wabbeln  ********************************/

for(zz=181; zz<397; zz+=6) Titlecopl[zz]=Titlecopl[zz+6];	
Titlecopl[397]=Wabber2[qi];
qi++;
if(qi>=4) qi=0;

/*************************************************************************/


if(*taste==0x57) *Col=0x00f;
	WaitVBeamII(170);
	}

Black();

*DMACon=0x000f; 
Instruments=Start[1];
FreeMem(Track,sizeof(struct FuchsTracker));

/***********************************************************************/

if(Choice==2) { LowScore(); Black(); goto ShowTitle; }

NewGame=1; Plaier=10; Level=0; Key=0; Steuerung=0; en=1;
T_Count=0; Plaierbefore=1; i=160; j=100; Hertz=0; HalfFrame=0; Hertz2=0;
HalfFrame2=0; StartNew=0; Livesight=0; LevNum=-1;
NeuWy=0; ShowTime=0; ShadowOldX=0; ShadowOldY=0;
screen=0; xx=0; p=0; x2=0; y2=0; NeuWx=0; LastBauka=0;
vx=0.0; sx=0.0; vy=0.0; sy=0.0; SCHWERKRAFT=9.81; 
Buchstabe=0; count3=0; qi=0; s_1=0; s_2=0; s_3=0; s_4=0; s_5=0; s_6=0; s_7=0; 
s_8=0; soundx=0; soundy=0; Volime=0; Senfo=0; Busy=0; s_9=0; BaukaTyp=1; 
TheFirstTime=1; Darkness=0; KugelAus=0; GameOver=0;

for(j=0; j<15; j++)
    	{
 	Colors[j]=Bauka1Color[j];
	}

for(i=0; i<13; i++)
   {
   for(j=0; j<13; j++)
    	{
 	Colors3[i][j]=Bauka1Color2[i][j];
	}
   }
 
for(j=0; j<100; j++)
    	{
	TeileInfo[j]=Bauka1TeileInfo[j];
    	}

Player->Heino[0].Lives=5;
Player->Heino[1].Lives=5;
Player->Heino[2].Lives=5;
Player->Heino[3].Lives=5;
Player->Heino[0].Level=0;
Player->Heino[1].Level=0;
Player->Heino[2].Level=0;
Player->Heino[3].Level=0;
Player->Heino[0].Zeit=0;
Player->Heino[1].Zeit=0;
Player->Heino[2].Zeit=0;
Player->Heino[3].Zeit=0;

PlayerON[0]=0;
PlayerON[1]=0;
PlayerON[2]=0;
PlayerON[3]=0;

ReadIn(Textplane,"df0:Font.cru"); 

MausAlt=(*Maus);

WinkelY=0;
WinkelX=0;
WinkelBodenX=0;
WinkelBodenY=0;
gx=SCHWERKRAFT;
vx=0.0;
gy=SCHWERKRAFT;
vy=0.0;
k=200.0;
m=2500.0;

saveplane=plane1;
plane1+=2113;
planewakel=plane1;

#asm
   move.l _plane1,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
copl[49]=a2;
copl[51]=a1;
#asm
   move.l _plane1,d3
   add.l #44,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
copl[53]=a2;
copl[55]=a1;
#asm
   move.l _plane1,d3
   add.l #88,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
copl[57]=a2;
copl[59]=a1;
#asm
   move.l _plane1,d3
   add.l #132,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
copl[61]=a2;
copl[63]=a1;
#asm
   move.l _plane1,d3
   add.l #176,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
copl[65]=a2;
copl[67]=a1;
#asm
   move.l _plane1,d3
   add.l #220,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
copl[69]=a2;
copl[71]=a1;
plane1=saveplane;

colset();

BltClear(Playfield.Planes[0], RASSIZE(352,1440), 1L);

if(Choice==1) Eingabe();

BltClear(Playfield.Planes[0], RASSIZE(352,1440), 1L);

/*************************************************************************/
/******************************** GAME ***********************************/
/*************************************************************************/

while(1)
  {
if(*taste==0x5d) ShowTime=1;
if(*taste==0x5b) ShowTime=0;

if(ShowTime==1) *Col=0xf09; 
/********************   Kugel Links/Rechts  *******************/
  sxalt=sx;

  ax=((gx*sinus[WinkelX])/32768)-((k*vx)/m);  
  vx+=(ax/16);
if(vx>50.0) vx=50.0;
if(vx<-50.0) vx=-50.0;
if(Steuerung!=1) sx+=(vx/16);
if(Steuerung==1) sx+=(WinkelBodenX/30);

  dx=(int)sx-x1;
  x1=(int)sx;

/*if(x1>303) { sx=303.0; vx*=Prall; x1=303; }*/
/*if(x1<0) { sx=0.0; vx*=Prall; x1=0; }*/

/********************   Kugel Hoch/Runter  *******************/
  syalt=sy;
  ay=((gy*sinus[WinkelY])/32768)-((k*vy)/m);  
  vy+=(ay/16);
if(vy>50.0) vy=50.0;
if(vy<-50.0) vy=-50.0;
if(Steuerung!=1) sy+=(vy/16);
if(Steuerung==1) sy+=(WinkelBodenY/30);

  dy=(int)sy-y1;
  y1=(int)sy;

/*if(y1>240) { sy=240.0; vy*=Prall; y1=240; }
if(y1<0) { sy=0.0; vy*=Prall; y1=0; }*/

/************************  KUGEL Display  ***********************/

Mo_X=x2/35;
Mo_Y=y2/23;

      DispSprite(KSprites[(8-Mo_Y)][(8-Mo_X)],x1,y1,15,0,0);
      DispSprite((KSprites[(8-Mo_Y)][(8-Mo_X)]+72),x1,y1,15,1,1);
if(KugelAus==1)
	{
        DispSprite(&LeerSpr,0,0,1,0,0);
       	DispSprite(&LeerSpr,0,0,1,0,1);
	}

	DispSprite(Bohnen+432,x2-8,y2-8,15,0,4);
	DispSprite(Bohnen+504,x2-8,y2-8,15,1,5);

if(HalfFrame2==1) 
	{ 
      if(Steuerung==0) 
	{
	DispSprite(Bohnen+144,StoryBoard->Level[LevNum].LevelXSchwer-7,StoryBoard->Level[LevNum].LevelYSchwer-35,15,0,6);
	DispSprite(Bohnen+216,StoryBoard->Level[LevNum].LevelXSchwer-7,StoryBoard->Level[LevNum].LevelYSchwer-35,15,1,7);
	}
	else {
	        DispSprite(&LeerSpr,0,0,1,0,6);
        	DispSprite(&LeerSpr,0,0,1,0,7);
	     }
	}
if(HalfFrame2==0) 
	{ 
	 if(Key==0) 
		{ 
		DispSprite(Bohnen,StoryBoard->Level[LevNum].KeyX-8,StoryBoard->Level[LevNum].KeyY-31,15,0,6);
		DispSprite(Bohnen+72,StoryBoard->Level[LevNum].KeyX-8,StoryBoard->Level[LevNum].KeyY-31,15,1,7);
		}
		else {
		        DispSprite(&LeerSpr,0,0,1,0,6);
        		DispSprite(&LeerSpr,0,0,1,0,7);
	     	     }
	*HoleCol=0x02a2;
	}

if(HalfFrame2==0) 
	{ 
      if(Livesight==0) 
		{
		DispSprite(Bohnen+288,StoryBoard->Level[LevNum].LebenX-5,StoryBoard->Level[LevNum].LebenY-31,15,0,2);
		DispSprite(Bohnen+360,StoryBoard->Level[LevNum].LebenX-5,StoryBoard->Level[LevNum].LebenY-31,15,1,3);
		}
		else {
		        DispSprite(&LeerSpr,0,0,1,0,2);
        		DispSprite(&LeerSpr,0,0,1,0,3);
	     	     }
	}
if(HalfFrame2==1) 
	{ 
        DispSprite(&LeerSpr,0,0,1,0,2);
       	DispSprite(&LeerSpr,0,0,1,0,3);
	}
	

/***************************************************************/

k=200.0;
WinkelFlaecheX=0; 
WinkelFlaecheY=0; 
Stand=0;
UnderGround(x1+8,y1+8);
SCHWERKRAFT=9.81;
/*************** Winkel **********************/
if(Stand==3 || Stand==4) WinkelFlaecheY=-FLAECHENWINKEL; 
if(Stand==7 || Stand==8) WinkelFlaecheX=FLAECHENWINKEL; 
if(Stand==11 || Stand==12) WinkelFlaecheY=FLAECHENWINKEL; 
if(Stand==16 || Stand==15) WinkelFlaecheX=-FLAECHENWINKEL; 
if(Stand==17 || Stand==18) 
        {
        WinkelFlaecheX=-FLAECHENWINKEL; 
        WinkelFlaecheY=-FLAECHENWINKEL; 
        }
if(Stand==5 || Stand==6) 
         {
        WinkelFlaecheX=FLAECHENWINKEL; 
        WinkelFlaecheY=-FLAECHENWINKEL; 
        }
if(Stand==9 || Stand==10) 
        {
        WinkelFlaecheX=FLAECHENWINKEL; 
        WinkelFlaecheY=FLAECHENWINKEL; 
        }
if(Stand==14 || Stand==13) 
        {
        WinkelFlaecheX=-FLAECHENWINKEL; 
        WinkelFlaecheY=FLAECHENWINKEL; 
        }
Senfo=0;
if(Stand==19 || Stand==20) { surex=sx; surey=sy; } 
if((Stand==31 || Stand==0) && NewGame==0) KugelFallTest();

if(BaukaTyp==1) if(Stand==21 || Stand==22 || Stand==23 || Stand==24) SCHWERKRAFT=1.1;
if(BaukaTyp==2) if(Stand==21 || Stand==22 || Stand==23 || Stand==24) { k=-1000.0; SCHWERKRAFT=44.0; }
if(BaukaTyp==3) if(Stand==21 || Stand==22 || Stand==23 || Stand==24) 
			{
			if(Richtung==0) 
				{
			        WinkelFlaecheX=0; 
			        WinkelFlaecheY=-FLAECHENWINKEL3; 
				}
			if(Richtung==1) 
				{
			        WinkelFlaecheX=0; 
			        WinkelFlaecheY=FLAECHENWINKEL3; 
				}
			if(Richtung==2) 
				{
			        WinkelFlaecheY=0; 
			        WinkelFlaecheX=-FLAECHENWINKEL3; 
				}
			if(Richtung==3) 
				{
			        WinkelFlaecheY=0; 
			        WinkelFlaecheX=FLAECHENWINKEL3; 
				}
			if(Richtung==4) 
				{
			        WinkelFlaecheX=FLAECHENWINKEL3; 
			        WinkelFlaecheY=-FLAECHENWINKEL3; 
				}
			if(Richtung==5) 
				{
			        WinkelFlaecheX=-FLAECHENWINKEL3; 
			        WinkelFlaecheY=-FLAECHENWINKEL3; 
				}
			if(Richtung==6) 
				{
			        WinkelFlaecheX=-FLAECHENWINKEL3; 
			        WinkelFlaecheY=FLAECHENWINKEL3; 
				}
			if(Richtung==7) 
				{
			        WinkelFlaecheX=FLAECHENWINKEL3; 
			        WinkelFlaecheY=FLAECHENWINKEL3; 
				}
			}
			else Richtung=RangeRand(8);

        MausPos();
x2=MausX;
y2=MausY;

if(HalfFrame==1) ShadowFlit(0,0,-((155-x2)/39),-((100-y2)/25),104,21); 
        else ShadowFlit(0,104,-((155-x2)/39),(-((100-y2)/25))+104,104,21); 

 WinkelBodenX=(MausX-156)/4;
 WinkelBodenY=(MausY-104)/3;

if(Steuerung==1)
	{
	if((T_Seconds-SteuerTime)>=15) Steuerung=2;
	}

gy=SCHWERKRAFT;
WinkelY=WinkelBodenY+WinkelFlaecheY;
if(WinkelY<0) { WinkelY*=-1; gy=(-SCHWERKRAFT); }
gx=SCHWERKRAFT;
WinkelX=WinkelBodenX+WinkelFlaecheX;
if(WinkelX<0) { WinkelX*=-1; gx=(-SCHWERKRAFT); }

Mo_X=x2/31;
Mo_Y=y2/20;

copl[79]=Colors[10-Mo_Y];
copl[81]=Colors[12-Mo_Y];

copl[107]=Colors[((10-Mo_Y)+(10-Mo_X))/2];
copl[109]=Colors[(((10-Mo_Y)+(10-Mo_X))/2)+2];

copl[83]=Colors[((10-Mo_Y)+Mo_X)/2];
copl[85]=Colors[(((10-Mo_Y)+Mo_X)/2)+2];

copl[103]=Colors[10-Mo_X];
copl[105]=Colors[12-Mo_X];

copl[87]=Colors[Mo_X];
copl[89]=Colors[Mo_X+2];

copl[91]=Colors[(Mo_X+Mo_Y)/2];
copl[93]=Colors[((Mo_X+Mo_Y)/2)+2];

copl[99]=Colors[((10-Mo_X)+Mo_Y)/2];
copl[101]=Colors[(((10-Mo_X)+Mo_Y)/2)+2];

copl[95]=Colors[Mo_Y];
copl[97]=Colors[Mo_Y+2];

Mo_X=x2/24;
Mo_Y=y2/16;
copl[75]=Colors3[Mo_Y][Mo_X]+0x222;
copl[77]=Colors3[Mo_Y][Mo_X];

if(Senfo==0 && KugelAus==0) ShadowBlit(KugelShadow,0,0,plane1,-((155-x2)/51)+x1+1,-((100-y2)/33)+y1,15,2); 

x1p8=x1+8;
y1p8=y1+8;

if(KugelTyp>=0 && KugelTyp<=99)
	{
	Flummi1Sound();
	if(soundx==1)
		{
		soundx=0;
		Volime=(int)abs(altv*2);
		if(Volime>64) Volime=64;
		zuf=RangeRand((int)2);
		if(zuf==1) Flummi1ON
		      else Flummi1ON
		}		
	if(soundy==1)
		{
		soundy=0;
		Volime=(int)abs(altv*2);
		if(Volime>64) Volime=64;
		zuf=RangeRand((int)2);
		if(zuf==1) Flummi1ON
		      else Flummi1ON
		}		
	}
if(KugelTyp>=100 && KugelTyp<=199)
	{
	Metal1Sound();
	Metal2Sound();
	if(soundx==1)
		{
		soundx=0;
		Volime=(int)abs(altv*2);
		if(Volime>64) Volime=64;
		zuf=RangeRand((int)2);
		if(zuf==1) Metal1ON
			else Metal2ON
		}		
	if(soundy==1)
		{
		soundy=0;
		Volime=(int)abs(altv*2);
		if(Volime>64) Volime=64;
		zuf=RangeRand((int)2);
		if(zuf==1) Metal1ON
			else Metal2ON
		}		
	}
if(KugelTyp>=200 && KugelTyp<=299)
	{
	Holz1Sound();
	Holz2Sound();
	if(soundx==1)
		{
		soundx=0;
		Volime=(int)abs(altv*2);
		if(Volime>64) Volime=64;
		zuf=RangeRand((int)2);
		if(zuf==1) Holz1ON
			else Holz2ON
		}		
	if(soundy==1)
		{
		soundy=0;
		Volime=(int)abs(altv*2);
		if(Volime>64) Volime=64;
		zuf=RangeRand((int)2);
		if(zuf==1) Holz1ON
			else Holz2ON
		}		
	}
if(KugelTyp>=300 && KugelTyp<=399)
	{
	Glas1Sound();
	Glas2Sound();
	if(soundx==1)
		{
		soundx=0;
		Volime=(int)abs(altv*2);
		if(Volime>64) Volime=64;
		zuf=RangeRand((int)2);
		if(zuf==1) Glas1ON
			else Glas2ON
		}		
	if(soundy==1)
		{
		soundy=0;
		Volime=(int)abs(altv*2);
		if(Volime>64) Volime=64;
		zuf=RangeRand((int)2);
		if(zuf==1) Glas1ON
			else Glas2ON
		}		
	}

CollWert=(*CollDat);
if((CollWert)&0x0200 && en==0)
	{
	EinsammelON
	Livesight=1;
	Player->Heino[Plaierbefore-1].Lives++;
        DispSprite(&LeerSpr,0,0,1,0,2);
        DispSprite(&LeerSpr,0,0,1,0,3);
	en=1;
	}

if(((CollWert)&0x0800) && HalfFrame2==0)
	{
	EinsammelON
	Key=1;
        DispSprite(&LeerSpr,0,0,1,0,4);
        DispSprite(&LeerSpr,0,0,1,0,5);
	}

 if((CollWert)&0x0800 && HalfFrame2)
	{
	EinsammelON
	Steuerung=1;
	SteuerTime=T_Seconds;
        DispSprite(&LeerSpr,0,0,1,0,6);
        DispSprite(&LeerSpr,0,0,1,0,7);
	}

if(*taste==0x41) NewGame=1;

Hertz++;
HalfFrame=0;
if(Hertz>1) { Hertz=0; HalfFrame=1; }

Hertz2++;
if(Hertz2>150) { Hertz2=0; HalfFrame2++; if(HalfFrame2>=2) HalfFrame2=0; }

EinsammelSound();

if(NewGame) 
	{
	x2=155;
	y2=104;
	ShadowFlit(0,0,-((155-x2)/39),-((100-y2)/25),104,21); 
	ShadowFlit(0,104,-((155-x2)/39),(-((100-y2)/25))+104,104,21); 
	InfoBox();
	}

/******************  KUGEL CHECK  ******************************/
if(Steuerung!=1 && x1>=0 && x1<=315 && y1>=0 && y1<=200)
{
if((int)ax<0 || dx<0)
{
FastCheckBlit(KugelCheck,0,0,Testplane,x1,y1,15,2);
BlitterWait();
Test=(*DMAConr&0x2000);
if(Test==0) { altv=(int)vx; vx*=Prall; sx=sxalt; if(Busy==0) soundx=1; }
}

if((int)ax>0 || dx>0)
{
FastCheckBlit(KugelCheck,32,0,Testplane,x1,y1,15,2);
BlitterWait();
Test=(*DMAConr&0x2000);
if(Test==0) { altv=(int)vx; vx*=Prall; sx=sxalt; if(Busy==0) soundx=1; }
}

if((int)ay<0 || dy<0)
{
FastCheckBlit(KugelCheck,64,0,Testplane,x1,y1,5,2);
BlitterWait();
Test=(*DMAConr&0x2000);
if(Test==0) { altv=(int)vy; vy*=Prall; sy=syalt; if(Busy==0) soundy=1;  }
}

if((int)ay>0 || dy>0)
{
FastCheckBlit(KugelCheck,96,10,Testplane,x1,y1+10,5,2);
BlitterWait();
Test=(*DMAConr&0x2000);
if(Test==0) { altv=(int)vy; vy*=Prall; sy=syalt; if(Busy==0) soundy=1; }
}
}

/****************************  ExtraHitMap Test  **************************/
if(Steuerung!=1 && x1>=0 && x1<=315 && y1>=0 && y1<=200)
{
if((int)ax<0 || dx<0)
{
FastCheckBlit(KugelCheck,0,0,ExtraTestplane,x1,y1,15,2);
BlitterWait();
Test=(*DMAConr&0x2000);
if(Test==0) 
      	{ 
      	altv=(int)vx; 
      	if(BaukaTyp==3) vx*=-1.3; 
		else vx*=Prall;
      	if(BaukaTyp==2 && Darkness==0) { Darkness=1; BildAus(); OutCount=T_Seconds; }
      	if(BaukaTyp==4 && Darkness==0) { KugelAus=1; OutCount=T_Seconds; }
      	sx=sxalt; 
      	if(Busy==0) soundx=1; 
  	}
}

if((int)ax>0 || dx>0)
{
FastCheckBlit(KugelCheck,32,0,ExtraTestplane,x1,y1,15,2);
BlitterWait();
Test=(*DMAConr&0x2000);
if(Test==0) 
      	{ 
      	altv=(int)vx; 
      	if(BaukaTyp==3) vx*=-1.3; 
		else vx*=Prall;
      	if(BaukaTyp==2 && Darkness==0) { Darkness=1; BildAus(); OutCount=T_Seconds; }
      	if(BaukaTyp==4 && Darkness==0) { KugelAus=1; OutCount=T_Seconds; }
      	sx=sxalt; 
      	if(Busy==0) soundx=1; 
  	}
}

if((int)ay<0 || dy<0)
{
FastCheckBlit(KugelCheck,64,0,ExtraTestplane,x1,y1,5,2);
BlitterWait();
Test=(*DMAConr&0x2000);
if(Test==0) 
      	{ 
      	altv=(int)vy; 
      	if(BaukaTyp==3) vy*=-1.3; 
		else vy*=Prall;
      	if(BaukaTyp==2 && Darkness==0) { Darkness=1; BildAus(); OutCount=T_Seconds; }
      	if(BaukaTyp==4 && Darkness==0) { KugelAus=1; OutCount=T_Seconds; }
      	sy=syalt; 
      	if(Busy==0) soundy=1; 
  	}
}

if((int)ay>0 || dy>0)
{
FastCheckBlit(KugelCheck,96,10,ExtraTestplane,x1,y1+10,5,2);
BlitterWait();
Test=(*DMAConr&0x2000);
if(Test==0) 
      	{ 
      	altv=(int)vy; 
      	if(BaukaTyp==3) vy*=-1.3; 
		else vy*=Prall;
      	if(BaukaTyp==2 && Darkness==0) { Darkness=1; BildAus(); OutCount=T_Seconds; }
      	if(BaukaTyp==4 && Darkness==0) { KugelAus=1; OutCount=T_Seconds; }
      	sy=syalt; 
      	if(Busy==0) soundy=1; 
  	}
}
}

if(Steuerung==1 && x1>=0 && x1<=315 && y1>=0 && y1<=200)
{
FastCheckBlit(KugelCheck,0,0,ExtraTestplane,x1,y1,15,2);
BlitterWait();
Test=(*DMAConr&0x2000);
if(Test==0) { altv=(int)vx; vx=0.0; vy=0.0; sx=sxalt; if(Busy==0) soundx=1; }

FastCheckBlit(KugelCheck,32,0,ExtraTestplane,x1,y1,15,2);
BlitterWait();
Test=(*DMAConr&0x2000);
if(Test==0) { altv=(int)vx; vx=0.0; vy=0.0; sx=sxalt; if(Busy==0) soundx=1; }

FastCheckBlit(KugelCheck,64,0,ExtraTestplane,x1,y1,5,2);
BlitterWait();
Test=(*DMAConr&0x2000);
if(Test==0) { altv=(int)vx; vx=0.0; vy=0.0; sy=syalt; if(Busy==0) soundy=1; }

FastCheckBlit(KugelCheck,96,10,ExtraTestplane,x1,y1+10,5,2);
BlitterWait();
Test=(*DMAConr&0x2000);
if(Test==0) { altv=(int)vx; vx=0.0; vy=0.0; sy=syalt; if(Busy==0) soundy=1; }
}

/******************  KUGEL CHECK 2 ******************************/
if(Steuerung==1 && x1>=0 && x1<=315 && y1>=0 && y1<=200)
{
vx=0.0; vy=0.0;
FastCheckBlit(KugelCheck,0,0,Testplane,x1,y1,15,2);
BlitterWait();
Test=(*DMAConr&0x2000);
if(Test==0) { altv=(int)vx; vx*=Prall; sx=sxalt; if(Busy==0) soundx=1; }

FastCheckBlit(KugelCheck,32,0,Testplane,x1,y1,15,2);
BlitterWait();
Test=(*DMAConr&0x2000);
if(Test==0) { altv=(int)vx; vx*=Prall; sx=sxalt; if(Busy==0) soundx=1; }

FastCheckBlit(KugelCheck,64,0,Testplane,x1,y1,5,2);
BlitterWait();
Test=(*DMAConr&0x2000);
if(Test==0) { altv=(int)vy; vy*=Prall; sy=syalt; if(Busy==0) soundy=1; }

FastCheckBlit(KugelCheck,96,10,Testplane,x1,y1+10,5,2);
BlitterWait();
Test=(*DMAConr&0x2000);
if(Test==0) { altv=(int)vy; vy*=Prall; sy=syalt; if(Busy==0) soundy=1; }
}
/***************************************************************/

if(soundx==1 && soundy==1)
	{
	if(vx>vy) soundy=0;
		else soundx=0;
	}

if(ShowTime==1) *Col=0x0000;  

if(Key==1)
{
Holecount=0;
while(Holecount<Hole)
{
if(x1p8>FinishX1[Holecount] && x1p8<FinishX2[Holecount] && y1p8>FinishY1[Holecount] && y1p8<FinishY2[Holecount])
	{
	Fin_Count[Holecount]++;
	if(Fin_Count[Holecount]>=250) 
		{
		NewGame=1;
		Fin_Count[Holecount]=0;
		}
	}
	else Fin_Count[Holecount]=0;
Holecount++;
}
}

if(Darkness==1)
	{
	if((T_Seconds-OutCount)>=10) Darkness=2;
	}
if(Darkness==2) { BildAn(); Darkness=0; }

if(KugelAus==1)
	{
	if((T_Seconds-OutCount)>=10) KugelAus=0;
	}

if(HalfFrame2==1) *HoleCol=0x0000;

if(PlayerON[0]==0 && PlayerON[1]==0 && PlayerON[2]==0 && PlayerON[3]==0) 
	{ 
	*DMACon=0x000f; 
	goto ShowTitle; 
	}
	
T_Count++;
if(T_Count>=50) 
	{ 
	T_Count=0; 
	T_Seconds++; 
	StoryBoard->Level[LevNum].LevelMaxTime--; 
	if(StoryBoard->Level[LevNum].LevelMaxTime<=0)
		{
		NewGame=1;
		T_Seconds+=60;
		Player->Heino[Plaierbefore-1].Lives--;
		if(Player->Heino[Plaierbefore-1].Lives==0) 
			{ 
			GameOver=1; 
			PlayerON[Plaierbefore-1]=0; 
			}
		}
	}

  WaitVBeam();

        WaitSound2();
  }

}


UnderGround(x,y)
int x,y;
{
register short Test=0;
register UBYTE *Adr,Bitnum;
int xq;
UBYTE Test1,Test2,Test3,Test4,Test5;

Adr=plane1;

y+=16;
x+=16;

xq=x;
x/=8;
y*=264;

Bitnum=7-(xq-(x*8));

Adr+=y+x;

Test1=(((*Adr)&(1<<Bitnum))>>Bitnum);
Test2=(((*(Adr+44))&(1<<Bitnum))>>Bitnum);
Test3=(((*(Adr+88))&(1<<Bitnum))>>Bitnum);
Test4=(((*(Adr+132))&(1<<Bitnum))>>Bitnum);
Test5=(((*(Adr+176))&(1<<Bitnum))>>Bitnum);

Test=(Test5<<4)|(Test4<<3)|(Test3<<2)|(Test2<<1)|Test1;

/*if(Test>25) *(Adr+220)|=(1<<Bitnum);*/

Stand=Test;
}


WaitVBeam()
{
while(VBeamPos()!=100) { }
}

WaitVBeamII(pos)
short pos;
{
while(VBeamPos()!=pos) { }
}


MausPos()
{
int Diff;

MausNeu=(*Maus);

Diff=(MausAlt&0xff)-(MausNeu&0xff);
if(Diff<-127) MausX+=(-255-Diff);
        else
        if(Diff>127) MausX+=(255-Diff);
                else
                MausX+=(Diff*-1);

Diff=(MausAlt>>8)-(MausNeu>>8);
if(Diff<-127) MausY+=(-255-Diff);
        else
        if(Diff>127) MausY+=(255-Diff);
                else
                
                MausY+=(Diff*-1);

if(MausX<0) MausX=0;  if(MausX>310) MausX=310;
if(MausY<0) MausY=0;  if(MausY>200) MausY=200;
MausAlt=MausNeu;
}


DispSprite(spr_adr,spr_x,spr_y,spr_height,spr_at,spr_num)
UWORD *spr_adr;
UWORD spr_x,spr_y,spr_height,spr_at,spr_num;
{
spr_x+=129;
spr_y+=41;
spr_height+=spr_y;
*spr_adr=(spr_y&0xff)<<8;
*spr_adr|=(spr_x>>1);
*(spr_adr+1)=(spr_height&0xff)<<8;
if(spr_at==1) *(spr_adr+1)|=0x80;
*(spr_adr+1)|=((spr_height&0x100)>>7);
*(spr_adr+1)|=((spr_y&0x100)>>6);
*(spr_adr+1)|=(spr_x&0x01);

#asm
  move.l 8(a5),d6
  move.w d6,_ad2
  swap d6
  move.w d6,_ad1
#endasm

if(spr_num==0) { copl[1]=ad1; copl[3]=ad2; }
if(spr_num==1) { copl[5]=ad1; copl[7]=ad2; }
if(spr_num==2) { copl[9]=ad1; copl[11]=ad2; }
if(spr_num==3) { copl[13]=ad1; copl[15]=ad2; }
if(spr_num==4) { copl[17]=ad1; copl[19]=ad2; }
if(spr_num==5) { copl[21]=ad1; copl[23]=ad2; }
if(spr_num==6) { copl[25]=ad1; copl[27]=ad2; }
if(spr_num==7) { copl[29]=ad1; copl[31]=ad2; }
}


ShadowBlit(von,x1,y1,nach,x2,y2,h1,w1)
UWORD x1,y1,x2,y2,h1,w1,*von,*nach;
{
int word1=0, word2=0, rest=0, zw=0, m1=0, ges=0;
src=von;
dest=nach;
x2+=16;
y2+=16;

zw=(x2/16);
ges=((h1<<6)+w1);
word1=(y1*40)+(x1/8);
word2=((y2*264)+(x2/8))+220;
rest=x2-(zw*16);

BlitterCopy(word1,word2,ges,rest,36,260);
}

ShadowClearBlit(von,x1,y1,nach,x2,y2,h1,w1)
UWORD x1,y1,x2,y2,h1,w1,*von,*nach;
{
int word1=0, word2=0, rest=0, zw=0, m1=0, ges=0;
src=von;
dest=nach;
x2+=16;
y2+=16;

zw=(x2/16);
ges=((h1<<6)+w1);
word1=(y1*40)+(x1/8);
word2=((y2*264)+(x2/8))+220;
rest=x2-(zw*16);

BlitterClearCopy(word1,word2,ges,rest,36,260);
}

ShadowFlit(x1,y1,x2,y2,h1,w1)
UWORD x1,y1,x2,y2,h1,w1;
{
int word1=0, word2=0, word3=0, rest=0, zw=0, m1=0, ges=0;
x2+=16;
y2+=16;

zw=(x2/16);
ges=((h1<<6)+w1);
word1=(((y2-16)*42)-2)+(x2/8);
word2=((y2*264)+(x2/8))+220;
rest=x2-(zw*16);
if(y1>0) BlitterShadowCopy2(word1,word2,ges,rest,0,224);
        else BlitterShadowCopy(word1,word2,ges,rest,0,224);
}


BlitterShadowCopy(Start1,Start2,HW,Mask1,mod1,mod2)
int Start1,Start2;
short HW,Mask1,mod1,mod2;
{
short a=0;
a = Mask1<<12;
a |= 0x0d30;

#asm
   move.l _S_shadowplane,d3
   move.l _S_plane1,d2
   add.l 12(a5),d2
   jsr _BlitterWait
   move.l d3,$dff050
   move.l d2,$dff054
   add.l 8(a5),d3
   move.l d3,$dff04c
   move.w #0,$dff064
   move.w #222,$dff066
   move.w #0,$dff062
   move.w -2(a5),$dff040
   clr.w $dff042
   move.w 18(a5),$dff058   
#endasm
}

BlitterShadowCopy2(Start1,Start2,HW,Mask1,mod1,mod2)
int Start1,Start2;
short HW,Mask1,mod1,mod2;
{
short a=0;
a = Mask1<<12;
a |= 0x0d30;

#asm
   move.l _S_shadowplane,d3
   move.l _S_plane1,d2
   add.l 12(a5),d2
   addi.l #4368,d3
   jsr _BlitterWait
   move.l d3,$dff050
   move.l d2,$dff054
   subi.l #4368,d3
   add.l 8(a5),d3
   move.l d3,$dff04c
   move.w #0,$dff064
   move.w #222,$dff066
   move.w #0,$dff062
   move.w -2(a5),$dff040
   clr.w $dff042
   move.w 18(a5),$dff058   
#endasm
}


ClearBlit(von,x1,y1,h1,w1)
UWORD x1,y1,h1,w1,*von;
{
int word1=0, word2=0, rest=0, zw=0, m1=0, ges=0;
src=von;
dest=von;
x1+=16;
y1+=16;

zw=(x1/16);
ges=((h1<<6)+w1);
word1=((y1*264)+(x1/8))+220;
rest=x1-(zw*16);

BlitterClear(word1,word1,ges,rest,260,260);
}

BlitterClear(Start1,Start2,HW,Mask1,mod1,mod2)
int Start1,Start2;
short HW,Mask1,mod1,mod2;
{
short a=0;
a = Mask1<<12;
a |= 0x0100;

#asm
   move.l _dest,d2
   add.l 12(a5),d2
   jsr _BlitterWait     
   move.l d2,$dff054
   move.w 30(a5),$dff066
   move.w -2(a5),$dff040
   clr.w $dff042
   move.w 18(a5),$dff058   
#endasm
}

FastBlit(von,x1,y1,nach,x2,y2,h1,w1)
UWORD x1,y1,x2,y2,h1,w1,*von,*nach;
{
int word1=0, word2=0, rest=0, zw=0, m1=0, ges=0;
src=von;
dest=nach;
m1=((20-w1)*2);
zw=(x2/16);
ges=((h1<<6)+w1);
word1=(y1*240)+(x1/8);
word2=(y2*264)+(x2/8);
rest=x2-(zw*16);
BlitterCopy(word1,word2,ges,rest,36,40);
}

BlitterCopy(Start1,Start2,HW,Mask1,mod1,mod2)
int Start1,Start2;
short HW,Mask1,mod1,mod2;
{
short a=0;
a = Mask1<<12;
a |= 0x0dfc;

#asm
   move.l _src,d3
   move.l _dest,d2
   add.l 8(a5),d3
   add.l 12(a5),d2
   jsr _BlitterWait
   move.l d3,$dff050
   move.l d2,$dff054
   move.l d2,$dff04c
   move.w 26(a5),$dff064
   move.w 30(a5),$dff066
   move.w 30(a5),$dff062
   move.w -2(a5),$dff040
   clr.w $dff042
   move.w 18(a5),$dff058   
#endasm
}

BlitterClearCopy(Start1,Start2,HW,Mask1,mod1,mod2)
int Start1,Start2;
short HW,Mask1,mod1,mod2;
{
short a=0;
a = Mask1<<12;
a |= 0x0df0;

#asm
   move.l _src,d3
   move.l _dest,d2
   add.l 8(a5),d3
   add.l 12(a5),d2
   jsr _BlitterWait
   move.l d3,$dff050
   move.l d2,$dff054
   move.l d2,$dff04c
   move.w 26(a5),$dff064
   move.w 30(a5),$dff066
   move.w 30(a5),$dff062
   move.w -2(a5),$dff040
   clr.w $dff042
   move.w 18(a5),$dff058   
#endasm
}

FastCheckBlit(von,x1,y1,nach,x2,y2,h1,w1)
UWORD x1,y1,x2,y2,h1,w1,*von,*nach;
{
int word1=0, word2=0, rest=0, zw=0, m1=0, ges=0;
src=von;
dest=nach;
m1=((20-w1)*2);
zw=(x2/16);
ges=((h1<<6)+w1);
word1=(y1*40)+(x1/8);
word2=(y2*40)+(x2/8);
rest=x2-(zw*16);
if(word1>=0 && word2>=0) BlitterCheckCopy(word1,word2,ges,rest,m1,m1);
}

BlitterCheckCopy(Start1,Start2,HW,Mask1,mod1,mod2)
int Start1,Start2;
short HW,Mask1,mod1,mod2;
{
short a=0;
a = Mask1<<12;
a |= 0x0cc0;

#asm
   move.l _src,d3
   move.l _dest,d2
   add.l 8(a5),d3
   add.l 12(a5),d2
   jsr _BlitterWait
   move.l d3,$dff050
   move.l d2,$dff04c
   move.w 26(a5),$dff064
   move.w 30(a5),$dff062
   move.w -2(a5),$dff040
   clr.w $dff042
   move.w 18(a5),$dff058   
#endasm
}

ReadIn(adr,name)
UBYTE *adr;
char *name;
{
long File,lock,Laenge;
struct FileInfoBlock *FIB;
register long Count=1,EndCount=0;
register char LocalCount=0,Wasgehtab=0;
unsigned char Startbyte,Nextbyte;
unsigned char *BufferStart1,*Bufferpointer1;
unsigned char *BufferStart2,*Bufferpointer2;

FIB=AllocMem(sizeof(struct FileInfoBlock),MEMF_CHIP|MEMF_CLEAR);

lock=Lock(name, ACCESS_READ);
if(lock==0) exit(0);
Examine(lock,FIB);
Laenge=FIB->fib_Size;
UnLock(lock);

File=Open(name,MODE_OLDFILE);
BufferStart1=AllocMem(Laenge,MEMF_CLEAR|MEMF_PUBLIC);
BufferStart2=adr;
Bufferpointer2=BufferStart2;
Bufferpointer1=BufferStart1;

Read(File,BufferStart1,Laenge);
Close(File);

Count=0;
EndCount=0;

while(Count<Laenge)
        {
        Wasgehtab=(*Bufferpointer1);
        Bufferpointer1++;
        Count++;

        if(Wasgehtab<0)
                {
                while(Wasgehtab<0)
                        {
                        *Bufferpointer2=(*Bufferpointer1);
                        Bufferpointer1++;
                        Bufferpointer2++;
                        Wasgehtab++;
                        EndCount++;
                        Count++;
                        }
                }

        if(Wasgehtab>0)
                {
                while(Wasgehtab>0)
                        {
                        *Bufferpointer2=(*Bufferpointer1);
                        Bufferpointer2++;
                        Wasgehtab--;
                        EndCount++;
                        }
                Bufferpointer1++;                
                Count++;
                }
        }

FreeMem(BufferStart1,Laenge);
FreeMem(FIB,sizeof(struct FileInfoBlock));
}

#asm
        public _BlitterWait
_BlitterWait:
waitblit: btst #14,$dff002
         bne.S waitblit 
         move.w #$ffff,$dff044
         move.w #$ffff,$dff046
         rts
#endasm

Load(adr,name)
UBYTE *adr;
char *name;
{
long File,lock,Laenge;
struct FileInfoBlock *FIB;

FIB=AllocMem(sizeof(struct FileInfoBlock),MEMF_CHIP|MEMF_CLEAR);

lock=Lock(name, ACCESS_READ);
if(lock==0) exit(0);
Examine(lock,FIB);
Laenge=FIB->fib_Size;
UnLock(lock);

File=Open(name,MODE_OLDFILE);
Read(File,adr,Laenge);
Close(File);

FreeMem(FIB,sizeof(struct FileInfoBlock));
}

Aufbau()
{
int z_x,z_y,x,y,a,b,putx=0,puty=0;
UBYTE Zwisch;

Hole=0;

for(a=0; a<8; a++)
   {
   for(b=0; b<12; b++)
        {
        Zwisch=(StoryBoard->Level[LevNum].AufbauData[a][b]-1);
	if(Zwisch>=0)
                {
                y=(Zwisch/11);
                x=(Zwisch-(y*11))*27;
                z_x=putx+16;
                z_y=puty+96;
                rp1.BitMap=&BaukaMap;
                rp2.BitMap=&Playfield;
 		if(y<8 && y>=0 && x>=0 && x<320)
		{
                ClipBlit(&rp1,x,y*162,&rp2,z_x,z_y,26,156,0xc0);
		}	
                z_x=putx;
                z_y=puty/6;
                rp1.BitMap=&ShadowSourceMap;
                rp2.BitMap=&ShadowMap;
 		if(y<8 && y>=0 && x>=0 && x<320)
		{
                ClipBlit(&rp1,x,y*27,&rp2,z_x,z_y,26,26,0xc0);
		}
                if(TeileInfo[Zwisch]==1)
                        {
                        rp1.BitMap=&ShadowSourceMap;
                        rp2.BitMap=&HitMap;
	 		if(y<8 && y>=0 && x>=0 && x<320)
			{
                        ClipBlit(&rp1,x,y*27,&rp2,z_x,z_y,26,26,0xc0);
			}
                        }
                if(TeileInfo[Zwisch]==4)
                        {
                        rp1.BitMap=&ShadowSourceMap;
                        rp2.BitMap=&ExtraHitMap;
	 		if(y<8 && y>=0 && x>=0 && x<320)
			{
                        ClipBlit(&rp1,x,y*27,&rp2,z_x,z_y,26,26,0xc0);
			}
                        }
                if(TeileInfo[Zwisch]==3)
                        {
	                FinishY1[Hole]=(puty/6)+6;
    	            	FinishX1[Hole]=putx+6;
        	        FinishY2[Hole]=(puty/6)+21;
            	    	FinishX2[Hole]=putx+21;
			Fin_Count[Hole]=0;
			Hole++;
                        }
		}
        putx+=26;
        }
   putx=0; puty+=156;
   }

	KugelSX=(float)StoryBoard->Level[LevNum].XKugel;
	KugelSY=(float)StoryBoard->Level[LevNum].YKugel-31;
}


LoadBaukas()
{
int i,j;

LevNum++;
if(LevNum>5) LevNum=0;

if(StoryBoard->Level[LevNum].NameBauka[0]==1 && LastBauka!=1)
{
#asm
   move.w #$22c,$dff1a6
   move.w #$22a,$dff1a8
   move.w #$6ff,$dff1aa
   move.w #$4dd,$dff1ac
   move.w #$2bb,$dff1ae
   move.w #$099,$dff1b0
#endasm

LastBauka=1;
BaukaTyp=1;
ReadIn(Baukaplane,"df0:Bauka.cru"); 
ReadIn(Shadowsourceplane,"df0:BaukaShadow.cru"); 

for(j=0; j<100; j++)
    	{
	TeileInfo[j]=Bauka1TeileInfo[j];
    	}

for(j=0; j<15; j++)
    	{
 	Colors[j]=Bauka1Color[j];
	}

for(i=0; i<13; i++)
   {
   for(j=0; j<13; j++)
    	{
 	Colors3[i][j]=Bauka1Color2[i][j];
	}
   }
}

if(StoryBoard->Level[LevNum].NameBauka[0]==3 && LastBauka!=3)
{
LastBauka=3;
BaukaTyp=3;
/*
#asm
   move.w #$cb2,$dff1a6
   move.w #$aa2,$dff1a8
   move.w #$c6f,$dff1aa
   move.w #$94d,$dff1ac
   move.w #$82b,$dff1ae
   move.w #$70c,$dff1b0
#endasm
*/
#asm
   move.w #$3c2,$dff1a6
   move.w #$2a2,$dff1a8
   move.w #$f69,$dff1aa
   move.w #$d48,$dff1ac
   move.w #$b25,$dff1ae
   move.w #$c05,$dff1b0
#endasm

ReadIn(Baukaplane,"df0:Bauka3.cru"); 
ReadIn(Shadowsourceplane,"df0:Bauka3Shadow.cru"); 

for(j=0; j<15; j++)
    	{
 	Colors[j]=Bauka3Color[j];
	}

for(j=0; j<100; j++)
    	{
	TeileInfo[j]=Bauka3TeileInfo[j];
    	}

for(i=0; i<13; i++)
   {
   for(j=0; j<13; j++)
    	{
 	Colors3[i][j]=Bauka3Color2[i][j];
	}
   }
}

x2=155;
y2=104;

Mo_X=x2/31;
Mo_Y=y2/20;

copl[79]=Colors[10-Mo_Y];
copl[81]=Colors[12-Mo_Y];

copl[107]=Colors[((10-Mo_Y)+(10-Mo_X))/2];
copl[109]=Colors[(((10-Mo_Y)+(10-Mo_X))/2)+2];

copl[83]=Colors[((10-Mo_Y)+Mo_X)/2];
copl[85]=Colors[(((10-Mo_Y)+Mo_X)/2)+2];

copl[103]=Colors[10-Mo_X];
copl[105]=Colors[12-Mo_X];

copl[87]=Colors[Mo_X];
copl[89]=Colors[Mo_X+2];

copl[91]=Colors[(Mo_X+Mo_Y)/2];
copl[93]=Colors[((Mo_X+Mo_Y)/2)+2];

copl[99]=Colors[((10-Mo_X)+Mo_Y)/2];
copl[101]=Colors[(((10-Mo_X)+Mo_Y)/2)+2];

copl[95]=Colors[Mo_Y];
copl[97]=Colors[Mo_Y+2];

Mo_X=x2/24;
Mo_Y=y2/16;
copl[75]=Colors3[Mo_Y][Mo_X]+0x222;
copl[77]=Colors3[Mo_Y][Mo_X];

}

Eingabe()
{
int i,j;
UWORD Zwisch1,l;

#asm
   move.w #$000,$dff1b2
   move.w #$000,$dff1b4
   move.w #$000,$dff1b6
   move.w #$000,$dff1b8
   move.w #$000,$dff1ba
   move.w #$000,$dff1bc
#endasm

rp1.BitMap=&TextMap;
rp2.BitMap=&Playfield;

ClipBlit(&rp,0,816,&rp2,16,96,320,132,0xc0);

for(i=228; i<1170; i+=30)
	{
	ClipBlit(&rp,0,960,&rp2,16,i,320,30,0xc0);
	}

ClipBlit(&rp,0,1038,&rp2,16,1176,320,24,0xc0);

PutFont("F1",2,50,450,&rp2);
PutFont("ONE PLAYER",10,98,450,&rp2);
PutFont("F2",2,50,570,&rp2);
PutFont("TWO PLAYER",10,98,570,&rp2);
PutFont("F3",2,50,690,&rp2);
PutFont("THREE PLAYER",12,98,690,&rp2);
PutFont("F4",2,50,810,&rp2);
PutFont("FOUR PLAYER",11,98,810,&rp2);

WaitVBeamII(280);
ICop();
WaitVBeamII(280);

#asm
   move.w #$f4f,$dff1b2
   move.w #$c0c,$dff1b4
   move.w #$a0a,$dff1b6
   move.w #$808,$dff1b8
   move.w #$606,$dff1ba
   move.w #$404,$dff1bc
#endasm

Rauf();

		Memory=AvailMem(MEMF_CHIP); 
		for(i=7; i>=0; i--)
			{
			FreiSpei[i]=Memory%10+0x30;
			Memory/=10;
			}
		FreiSpei[8]='\0';
	        PutFont(&FreiSpei[0],9,32,930,&rp2);

while(1)
	{
	if(*taste==0x5f) { HowMany=1; break; }
	if(*taste==0x5d) { HowMany=2; break; }
	if(*taste==0x5b) { HowMany=3; break; }
	if(*taste==0x59) { HowMany=4; break; }
	}

/*Runter();*/

for(j=228; j<1170; j+=30)
	{
	ClipBlit(&rp,0,960,&rp2,16,j,320,30,0xc0);
	}
ClipBlit(&rp,0,1038,&rp2,16,1176,320,24,0xc0);

	PutFont("ENTER YOUR NAME!",16,54,1080,&rp2);

for(i=0; i<HowMany; i++)
	{

for(j=480; j<630; j+=30)
	{
	ClipBlit(&rp,0,960,&rp2,16,j,320,30,0xc0);
	}

	Delay(15);
	if(i==0)
		{
		PutFont("PLAYER 1: ",11,21,480,&rp2);
		Tasten(i);
		PlayerON[0]=1;
		}
	if(i==1)
		{
		PutFont("PLAYER 2: ",11,21,480,&rp2);
		Tasten(i);
		PlayerON[1]=1;
		}
	if(i==2)
		{
		PutFont("PLAYER 3: ",11,21,480,&rp2);
		Tasten(i);
		PlayerON[2]=1;
		}
	if(i==3)
		{
		PutFont("PLAYER 4: ",11,21,480,&rp2);
		Tasten(i);
		PlayerON[3]=1;
		}
	}

Runter();
Runte=1;
}


Tasten(This)
short This;
{
int j=0;
int TopX,TopY;
unsigned char OldTaste=0,Toaste;

TopX=155;
TopY=480;

PutFont("|",1,TopX,TopY,&rp2);

while(1)
{
Toaste=*taste;
if(OldTaste!=Toaste)
  {
  if(Toaste==0x7d)
  	{
	TopX=155; 
	ClipBlit(&rp2,155,960,&rp2,155,480,189,120,0xc0);
        PutFont("|",1,TopX,TopY,&rp2);
	for(j=0; j<30; j++)
		{
		Player->Heino[This].name[j]=0;
		}
        j=0;
	}

  if(Toaste==0x77)
  	{
	Player->Heino[This].name[j]='\0';
	ClipBlit(&rp2,155,960,&rp2,155,480,189,120,0xc0);
	break;
	}

if(TopX<304)
{
switch(Toaste)
   {
   case 0xbf:
   PutFont("A",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='A';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0x95:
   PutFont("B",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='B';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0x99:
   PutFont("C",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='C';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xbb:
   PutFont("D",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='D';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xdb:
   PutFont("E",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='E';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xb9:
   PutFont("F",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='F';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xb7:
   PutFont("G",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='G';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xb5:
   PutFont("H",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='H';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xd1:
   PutFont("I",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='I';
	j++;
   TopX+=4; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xb3:
   PutFont("J",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='J';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xb1:
   PutFont("K",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='K';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xaf:
   PutFont("L",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='L';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0x91:
   PutFont("M",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='M';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0x93:
   PutFont("N",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='N';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xcf:
   PutFont("O",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='O';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xcd:
   PutFont("P",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='P';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xdf:
   PutFont("Q",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='Q';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xd9:
   PutFont("R",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='R';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xbd:
   PutFont("S",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='S';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xd7:
   PutFont("T",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='T';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xd3:
   PutFont("U",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='U';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0x97:
   PutFont("V",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='V';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xdd:
   PutFont("W",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='W';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0x9b:
   PutFont("X",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='X';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0x9d:
   PutFont("Y",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='Y';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xd5:
   PutFont("Z",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='Z';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xfd:
   PutFont("1",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='1';
	j++;
   TopX+=5; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xfb:
   PutFont("2",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='2';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xf9:
   PutFont("3",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='3';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xf7:
   PutFont("4",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='4';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xf5:
   PutFont("5",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='5';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xf3:
   PutFont("6",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='6';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xf1:
   PutFont("7",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='7';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xef:
   PutFont("8",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='8';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xed:
   PutFont("9",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='9';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0xeb:
   PutFont("0",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]='0';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   case 0x7f:
   PutFont(" ",1,TopX,TopY,&rp2);
	Player->Heino[This].name[j]=' ';
	j++;
   TopX+=16; 
   PutFont("|",1,TopX,TopY,&rp2);
   break;
   default:
   break;
   }
 }
}
OldTaste=Toaste;
}
}


PutFont(Stext,anz,x,y,rapo)
char *Stext;
int anz,y,x;
long rapo;
{
register short i=0,Ende=0;

while(Ende==0)
  {
  switch(*(Stext+i))         
   {
   case 'A':
   ClipBlit(&rp,0,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'B':
   ClipBlit(&rp,16,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'C':
   ClipBlit(&rp,32,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'D':
   ClipBlit(&rp,48,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'E':
   ClipBlit(&rp,64,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'F':
   ClipBlit(&rp,80,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'G':
   ClipBlit(&rp,96,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'H':
   ClipBlit(&rp,112,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'I':
   ClipBlit(&rp,128,0,rapo,x,y,4,72,0xc0);
   x+=4;
   break;
   case 'J':
   ClipBlit(&rp,132,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'K':
   ClipBlit(&rp,148,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'L':
   ClipBlit(&rp,164,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'M':
   ClipBlit(&rp,180,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'N':
   ClipBlit(&rp,196,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'O':
   ClipBlit(&rp,212,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'P':
   ClipBlit(&rp,228,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'Q':
   ClipBlit(&rp,244,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'R':
   ClipBlit(&rp,260,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'S':
   ClipBlit(&rp,276,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'T':
   ClipBlit(&rp,292,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'U':
   ClipBlit(&rp,0,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'V':
   ClipBlit(&rp,16,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'W':
   ClipBlit(&rp,32,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'X':
   ClipBlit(&rp,48,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'Y':
   ClipBlit(&rp,64,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'Z':
   ClipBlit(&rp,80,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '1':
   ClipBlit(&rp,96,72,rapo,x,y,5,72,0xc0);
   x+=5;
   break;
   case '2':
   ClipBlit(&rp,101,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '3':
   ClipBlit(&rp,117,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '4':
   ClipBlit(&rp,133,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '5':
   ClipBlit(&rp,149,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '6':
   ClipBlit(&rp,165,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '7':
   ClipBlit(&rp,181,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '8':
   ClipBlit(&rp,197,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '9':
   ClipBlit(&rp,213,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '0':
   ClipBlit(&rp,229,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '!':
   ClipBlit(&rp,298,72,rapo,x,y,6,72,0xc0);
   x+=6;
   break;
   case '?':
   ClipBlit(&rp,282,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '%':
   ClipBlit(&rp,112,312,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '.':
   ClipBlit(&rp,245,72,rapo,x,y,4,72,0xc0);
   x+=4;
   break;
   case ',':
   ClipBlit(&rp,249,72,rapo,x,y,5,14,0xc0);
   x+=5;
   break;
   case '-':
   ClipBlit(&rp,266,84,rapo,x,y,16,14,0xc0);
   x+=16;
   break;
   
case '#':
   ClipBlit(&rp,28,312,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   
case '=':
   ClipBlit(&rp,42,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;

case '|':
   ClipBlit(&rp,0,144,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   
case '>':
   ClipBlit(&rp,56,312,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   
case '<':
   ClipBlit(&rp,84,312,rapo,x,y,16,72,0xc0);
   x+=16;
   break;

case ' ':
   ClipBlit(&rp,56,144,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   
case '*':
   ClipBlit(&rp,98,312,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   
case '+':
   ClipBlit(&rp,154,312,rapo,x,y,16,72,0xc0);
   x+=16;
   break;

case ':':
   ClipBlit(&rp,261,72,rapo,x,y-6,5,84,0xc0);
   x+=5;
   break;
   
case '_':
   ClipBlit(&rp,154,210,rapo,x,y,16,72,0xc0);
   x+=16;
   break;

case '\0':
   Ende=1;
   break;

   default:
   break;
   }
i++;
  }   
}



PrintFont(text,x,y,rapo)
char *text;
int y,x;
long rapo;
{
short i=0,Ende=0,NoPieps;
 
/*   ClipBlit(&rp,0,144,rapo,x,y,16,72,0xc0);*/
Delay(4);

while(Ende==0)
  {
  NoPieps=0;
  switch(*(text+i))         
   {
   case 'A':
   ClipBlit(&rp,0,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'B':
   ClipBlit(&rp,16,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'C':
   ClipBlit(&rp,32,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'D':
   ClipBlit(&rp,48,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'E':
   ClipBlit(&rp,64,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'F':
   ClipBlit(&rp,80,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'G':
   ClipBlit(&rp,96,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'H':
   ClipBlit(&rp,112,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'I':
   ClipBlit(&rp,128,0,rapo,x,y,4,72,0xc0);
   x+=4;
   break;
   case 'J':
   ClipBlit(&rp,132,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'K':
   ClipBlit(&rp,148,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'L':
   ClipBlit(&rp,164,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'M':
   ClipBlit(&rp,180,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'N':
   ClipBlit(&rp,196,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'O':
   ClipBlit(&rp,212,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'P':
   ClipBlit(&rp,228,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'Q':
   ClipBlit(&rp,244,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'R':
   ClipBlit(&rp,260,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'S':
   ClipBlit(&rp,276,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'T':
   ClipBlit(&rp,292,0,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'U':
   ClipBlit(&rp,0,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'V':
   ClipBlit(&rp,16,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'W':
   ClipBlit(&rp,32,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'X':
   ClipBlit(&rp,48,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'Y':
   ClipBlit(&rp,64,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case 'Z':
   ClipBlit(&rp,80,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '1':
   ClipBlit(&rp,96,72,rapo,x,y,5,72,0xc0);
   x+=5;
   break;
   case '2':
   ClipBlit(&rp,101,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '3':
   ClipBlit(&rp,117,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '4':
   ClipBlit(&rp,133,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '5':
   ClipBlit(&rp,149,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '6':
   ClipBlit(&rp,165,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '7':
   ClipBlit(&rp,181,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '8':
   ClipBlit(&rp,197,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '9':
   ClipBlit(&rp,213,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '0':
   ClipBlit(&rp,229,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '!':
   ClipBlit(&rp,298,72,rapo,x,y,6,72,0xc0);
   x+=6;
   break;
   case '?':
   ClipBlit(&rp,282,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '%':
   ClipBlit(&rp,112,312,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   case '.':
   ClipBlit(&rp,245,72,rapo,x,y,4,72,0xc0);
   x+=4;
   break;
   case ',':
   ClipBlit(&rp,249,72,rapo,x,y,5,14,0xc0);
   x+=5;
   break;
   case '-':
   ClipBlit(&rp,266,84,rapo,x,y,16,14,0xc0);
   x+=16;
   break;
   
case '#':
   ClipBlit(&rp,28,312,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   
case '=':
   ClipBlit(&rp,42,72,rapo,x,y,16,72,0xc0);
   x+=16;
   break;

case '|':
   ClipBlit(&rp,0,144,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   
case '>':
   ClipBlit(&rp,56,312,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   
case '<':
   ClipBlit(&rp,84,312,rapo,x,y,16,72,0xc0);
   x+=16;
   break;

case ' ':
   ClipBlit(&rp,56,144,rapo,x,y,16,72,0xc0);
   x+=16;
   NoPieps=1;
   break;
   
case '*':
   ClipBlit(&rp,98,312,rapo,x,y,16,72,0xc0);
   x+=16;
   break;
   
case '+':
   ClipBlit(&rp,154,312,rapo,x,y,16,72,0xc0);
   x+=16;
   break;

case ':':
   ClipBlit(&rp,261,72,rapo,x,y-6,5,84,0xc0);
   x+=5;
   break;
   
case '_':
   ClipBlit(&rp,154,210,rapo,x,y,16,72,0xc0);
   x+=16;
   break;

case '\0':
   Ende=1;
   break;

   default:
   NoPieps=1;
   break;
   }
   ClipBlit(&rp,0,144,rapo,x,y,16,72,0xc0);
i++;
 Delay(2);
if(NoPieps==0) PiepSound();
  }   
   ClipBlit(&rp,56,144,rapo,x,y,16,72,0xc0);
}

WaitSound()
{
if(Loop1==0) *Laenge1=1;
if(Loop2==0) *Laenge2=1;
if(Loop3==0) *Laenge3=1;
if(Loop4==0) *Laenge4=1;
}

WaitSound2()
{
*Laenge1=1;
*Laenge2=1;
*Laenge3=1;
*Laenge4=1;
}


PlayMusik()
{
int i;
UWORD Channels=0;
 
if(Note1!=0) *DMACon=0x0001;
if(Note2!=0) *DMACon=0x0002;
if(Note3!=0) *DMACon=0x0004;
if(Note4!=0) *DMACon=0x0008;

if(Note1!=0)
{
*Adresse1=Start[Instrument1];
*Laenge1=Laenge[Instrument1];
*Period1=Note1;
*Volume1=Volume[Instrument1];
Channels+=1;
}

if(Note2!=0)
{
*Adresse2=Start[Instrument2];
*Laenge2=Laenge[Instrument2];
*Period2=Note2;
*Volume2=Volume[Instrument2];
Channels+=2;
}

if(Note3!=0)
{
*Adresse3=Start[Instrument3];
*Laenge3=Laenge[Instrument3];
*Period3=Note3;
*Volume3=Volume[Instrument3];
Channels+=4;
}

if(Note4!=0)
{
*Adresse4=Start[Instrument4];
*Laenge4=Laenge[Instrument4];
*Period4=Note4;
*Volume4=Volume[Instrument4];
Channels+=8;
}
for(i=1; i<50; i++);
*DMACon=0x8000+Channels; 
}


InfoBox()
{
short Stunden,Minuten,Sekunden,CopOn,Entsch;
char Zeitstring[20];

copl[43]=0x0000;
        DispSprite(&LeerSpr,0,0,1,0,0);
        DispSprite(&LeerSpr,0,0,1,0,1);
        DispSprite(&LeerSpr,0,0,1,0,2);
        DispSprite(&LeerSpr,0,0,1,0,3);
        DispSprite(&LeerSpr,0,0,1,0,4);
        DispSprite(&LeerSpr,0,0,1,0,5);
        DispSprite(&LeerSpr,0,0,1,0,6);
        DispSprite(&LeerSpr,0,0,1,0,7);

#asm
   move.w #$f4f,$dff1b2
   move.w #$c0c,$dff1b4
   move.w #$a0a,$dff1b6
   move.w #$808,$dff1b8
   move.w #$606,$dff1ba
   move.w #$404,$dff1bc
#endasm

if(PlayerON[0]==0 && PlayerON[1]==0 && PlayerON[2]==0 && PlayerON[3]==0) 
	{
	ClipBlit(&rp1,0,216,&rp2,44,216,256,180,0xc0);
	ClipBlit(&rp1,0,396,&rp2,44,396,256,300,0xc0);
	ClipBlit(&rp1,0,396,&rp2,44,696,256,300,0xc0);
	ClipBlit(&rp1,0,696,&rp2,44,996,256,120,0xc0);
	PrintFont("GAME OVER",100,510,&rp2);
	PrintFont("ALL PLAYERS",84,660,&rp2);
	WaitMouseKlick();
	Runter();
	}
else {
if(TheFirstTime==0)
{

ClipBlit(&rp1,0,216,&rp2,44,216,256,180,0xc0);
ClipBlit(&rp1,0,396,&rp2,44,396,256,300,0xc0);
ClipBlit(&rp1,0,396,&rp2,44,696,256,300,0xc0);
ClipBlit(&rp1,0,696,&rp2,44,996,256,120,0xc0);

if(GameOver==0)
{
PrintFont("YOUR TIME:",100,510,&rp2);

Minuten=((T_Seconds-Player->Heino[Plaierbefore-1].Zeit)/60);
Sekunden=((T_Seconds-Player->Heino[Plaierbefore-1].Zeit)-(Minuten*60));

Zeitstring[0]=(Minuten/10)%10+0x30;
Zeitstring[1]=Minuten%10+0x30;
Zeitstring[2]=':';
Zeitstring[3]=(Sekunden/10)%10+0x30;
Zeitstring[4]=Sekunden%10+0x30;
Zeitstring[5]='\0';
PrintFont(&Zeitstring[0],135,606,&rp2);
}

if(GameOver==1) PrintFont("GAME OVER",100,630,&rp2);
GameOver=0;

WaitMouseKlick();
ClipBlit(&rp1,0,1062,&rp2,44,216,256,900,0xc0);

Runter();

if(Plaier<=HowMany) Player->Heino[Plaierbefore-1].Zeit=T_Seconds;
}

TheFirstTime=0;

Plaier++;
if(PlayerON[1]==0 && Plaier==2) Plaier++; 
if(PlayerON[2]==0 && Plaier==3) Plaier++; 
if(PlayerON[3]==0 && Plaier==4) Plaier++; 
en=0;

if(Plaier>HowMany) 
	{
	if(PlayerON[0]==1) Plaier=1;
		else if(PlayerON[1]==1) Plaier=2;
			else if(PlayerON[2]==1) Plaier=3;
				else if(PlayerON[3]==1) Plaier=4;
	Level++;
        /*************** Neuen Level Einladen ********************/
	LoadBaukas(); 
	KugelTyp=Random(400);        
	if(KugelTyp>=0 && KugelTyp<=99)
		{
		FLUMMI
		Entsch=1;
		}
	if(KugelTyp>=100 && KugelTyp<=199)
		{
		EISEN
		Entsch=1;
		}
	if(KugelTyp>=200 && KugelTyp<=299)
		{
		HOLZ
		Entsch=1;
		}
	if(KugelTyp>=300 && KugelTyp<=399)
		{
		Entsch=2;
		GLAS
		}
for(i=0; i<9; i++)
   {
   for(j=0; j<9; j++)
    	{
 	if(Entsch==1) KSprites[i][j]=(KugelImages+(i*1296)+(j*144));
 	if(Entsch==2) KSprites[i][j]=(KugelImages2+(i*1296)+(j*144));
	}
   }
       BltClear(Playfield.Planes[0], RASSIZE(352,1440), 1L);
        BltClear(ShadowMap.Planes[0], RASSIZE(336L,220L), 1L);
        BltClear(HitMap.Planes[0], RASSIZE(320L,220L), 1L);
        BltClear(ExtraHitMap.Planes[0], RASSIZE(320L,220L), 1L);
	Aufbau();
	CopOn=1;
	}

Plaierbefore=Plaier;

	Busy=0;
	WinkelY=0;
	WinkelX=0;
	WinkelBodenX=0;
	WinkelBodenY=0;
	gx=SCHWERKRAFT;
	vx=0.0;
	gy=SCHWERKRAFT;
	vy=0.0;
	k=200.0;
	Key=0;
	Steuerung=0;		
	Livesight=0;
	sx=(float)(StoryBoard->Level[LevNum].XKugel);
	sy=(float)(StoryBoard->Level[LevNum].YKugel-31);
	sxalt=sx;
	syalt=sy;

Player->Heino[Plaier-1].Level++;

copl[43]=0x0000;

/*************  Aufbau!!! ****************************/

rp1.BitMap=&TextMap;
rp2.BitMap=&Playfield;
ClipBlit(&rp2,44,216,&rp1,0,1062,256,900,0xc0);

Rauf();

ClipBlit(&rp1,0,216,&rp2,44,216,256,180,0xc0);
ClipBlit(&rp1,0,396,&rp2,44,396,256,300,0xc0);
ClipBlit(&rp1,0,396,&rp2,44,696,256,300,0xc0);
ClipBlit(&rp1,0,696,&rp2,44,996,256,120,0xc0);

PrintFont("PLAYTIME:",105,510,&rp2);
PrintFont("03:00 MINUTES",75,606,&rp2);

PrintFont("BALLTYPE:",100,726,&rp2);
	if(KugelTyp>=0 && KugelTyp<=99)
		{
		PrintFont("RUBBER",120,822,&rp2);
		FLUMMI
		}
	if(KugelTyp>=100 && KugelTyp<=199)
		{
		PrintFont("IRON",135,822,&rp2);
		EISEN
		}
	if(KugelTyp>=200 && KugelTyp<=299)
		{
		PrintFont("WOOD",135,822,&rp2);
		HOLZ
		}
	if(KugelTyp>=300 && KugelTyp<=399)
		{
		PrintFont("GLASS",130,822,&rp2);
		GLAS
		}

StoryBoard->Level[LevNum].LevelMaxTime=180;

WaitMouseKlick();

ClipBlit(&rp1,0,216,&rp2,44,216,256,180,0xc0);
ClipBlit(&rp1,0,396,&rp2,44,396,256,300,0xc0);
ClipBlit(&rp1,0,396,&rp2,44,696,256,300,0xc0);
ClipBlit(&rp1,0,696,&rp2,44,996,256,120,0xc0);

PrintFont("PLAYER:",55,432,&rp2);
PrintFont(Player->Heino[Plaier-1].name,75,528,&rp2);

Stunden=(Player->Heino[Plaier-1].Zeit/3600);
Minuten=(Player->Heino[Plaier-1].Zeit-(Stunden*3600))/60;
Sekunden=(Player->Heino[Plaier-1].Zeit-(Stunden*3600)-(Minuten*60));

PrintFont("FORMER TIME:",55,672,&rp2);
Zeitstring[0]=(Stunden/10)%10+0x30;
Zeitstring[1]=Stunden%10+0x30;
Zeitstring[2]=':';
Zeitstring[3]=(Minuten/10)%10+0x30;
Zeitstring[4]=Minuten%10+0x30;
Zeitstring[5]=':';
Zeitstring[6]=(Sekunden/10)%10+0x30;
Zeitstring[7]=Sekunden%10+0x30;
Zeitstring[8]='\0';
PrintFont(&Zeitstring[0],75,768,&rp2);

PrintFont("LEVEL:",55,912,&rp2);
Zeitstring[0]=((Player->Heino[Plaier-1].Level)/10)%10+0x30;
Zeitstring[1]=(Player->Heino[Plaier-1].Level)%10+0x30;
Zeitstring[2]='\0';
PrintFont(&Zeitstring[0],75,1008,&rp2);

PrintFont("LIVES:",200,912,&rp2);
Zeitstring[0]=((Player->Heino[Plaier-1].Lives)/10)%10+0x30;
Zeitstring[1]=(Player->Heino[Plaier-1].Lives)%10+0x30;
Zeitstring[2]='\0';
PrintFont(&Zeitstring[0],220,1008,&rp2);

T_Seconds=Player->Heino[Plaier-1].Zeit;

WaitMouseKlick();

if(KugelTyp>=0 && KugelTyp<=99)
{
#asm
   move.w #$f44,$dff1b2
   move.w #$c00,$dff1b4
   move.w #$a00,$dff1b6
   move.w #$800,$dff1b8
   move.w #$600,$dff1ba
   move.w #$400,$dff1bc
#endasm
}

if(KugelTyp>=100 && KugelTyp<=199)
{
#asm
   move.w #$dde,$dff1b2
   move.w #$bbc,$dff1b4
   move.w #$99a,$dff1b6
   move.w #$778,$dff1b8
   move.w #$667,$dff1ba
   move.w #$445,$dff1bc
#endasm
}

if(KugelTyp>=200 && KugelTyp<=299)
{
#asm
   move.w #$ca7,$dff1b2
   move.w #$a86,$dff1b4
   move.w #$975,$dff1b6
   move.w #$854,$dff1b8
   move.w #$643,$dff1ba
   move.w #$532,$dff1bc
#endasm
}

if(KugelTyp>=300 && KugelTyp<=399)
{
#asm
   move.w #$0ff,$dff1b2
   move.w #$0aa,$dff1b4
   move.w #$088,$dff1b6
   move.w #$066,$dff1b8
   move.w #$055,$dff1ba
   move.w #$033,$dff1bc
#endasm
}

ClipBlit(&rp1,0,1062,&rp2,44,216,256,900,0xc0);
copl[43]=0x0024;
NewGame=0;
	MausAlt=(*Maus);
	MausX=155;
	MausY=104;
}
}

WaitMouseKlick()
{
while(1)
  {
  if(!(*Mtaste&0x40)) break;
  }
}

FontPrint(Stext)
char Stext;
{
register char text2;

text2=Stext;

switch(text2)         
   {
   case 'A':
   BltBitMap(&ShadowSourceMap,0,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'B':
   BltBitMap(&ShadowSourceMap,8,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'C':
   BltBitMap(&ShadowSourceMap,16,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'D':
   BltBitMap(&ShadowSourceMap,24,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'E':
   BltBitMap(&ShadowSourceMap,32,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'F':
   BltBitMap(&ShadowSourceMap,40,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'G':
   BltBitMap(&ShadowSourceMap,48,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'H':
   BltBitMap(&ShadowSourceMap,56,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'I':
   BltBitMap(&ShadowSourceMap,64,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'J':
   BltBitMap(&ShadowSourceMap,72,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'K':
   BltBitMap(&ShadowSourceMap,80,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'L':
   BltBitMap(&ShadowSourceMap,88,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'M':
   BltBitMap(&ShadowSourceMap,96,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'N':
   BltBitMap(&ShadowSourceMap,104,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'O':
   BltBitMap(&ShadowSourceMap,112,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'P':
   BltBitMap(&ShadowSourceMap,120,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'Q':
   BltBitMap(&ShadowSourceMap,128,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'R':
   BltBitMap(&ShadowSourceMap,136,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'S':
   BltBitMap(&ShadowSourceMap,144,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'T':
   BltBitMap(&ShadowSourceMap,152,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'U':
   BltBitMap(&ShadowSourceMap,160,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'V':
   BltBitMap(&ShadowSourceMap,168,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'W':
   BltBitMap(&ShadowSourceMap,176,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'X':
   BltBitMap(&ShadowSourceMap,184,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'Y':
   BltBitMap(&ShadowSourceMap,192,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case 'Z':
   BltBitMap(&ShadowSourceMap,200,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case '1':
   BltBitMap(&ShadowSourceMap,208,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case '2':
   BltBitMap(&ShadowSourceMap,216,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case '3':
   BltBitMap(&ShadowSourceMap,224,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case '4':
   BltBitMap(&ShadowSourceMap,232,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case '5':
   BltBitMap(&ShadowSourceMap,240,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case '6':
   BltBitMap(&ShadowSourceMap,248,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case '7':
   BltBitMap(&ShadowSourceMap,256,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case '8':
   BltBitMap(&ShadowSourceMap,264,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case '9':
   BltBitMap(&ShadowSourceMap,272,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case '0':
   BltBitMap(&ShadowSourceMap,280,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case '.':
   BltBitMap(&ShadowSourceMap,288,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case ':':
   BltBitMap(&ShadowSourceMap,296,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case '!':
   BltBitMap(&ShadowSourceMap,304,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case ',':
   BltBitMap(&ShadowSourceMap,312,0,&Playfield,322,700,8,45,0xc0,0xff,0);
   break;
   case '':
   StartNew=1;
   break;
   default:
   break;
   }
}   

Rauf()
{
int i,j;

for(i=0xff; i>0x29; i-=3)
	{
	copl[110]=i<<8|0x01; 
	for(j=0; j<80; j++) { } 
	WaitVBeamII(280);
	}
copl[110]=0x2901; 
}

Runter()
{
int i,j;

for(i=0x29; i<0xff; i+=3)
	{
	copl[110]=i<<8|0x01; 
	for(j=0; j<80; j++) { } 
	WaitVBeamII(280);
	}
copl[110]=0xff01; 
}

OpenDev() 
{
  struct IORequest *io;
  port=CreatePort(0,0);
  io=(struct IORequest *)AllocMem(sizeof(struct IOExtTD),MEMF_CLEAR|MEMF_PUBLIC);
  io->io_Message.mn_Node.ln_Type = NT_MESSAGE;
  io->io_Message.mn_Length = sizeof(struct IOExtTD);
  io->io_Message.mn_ReplyPort = port;
  request = (struct IOExtTD *) io;
  OpenDevice(TD_NAME,0,request,0);
}


MotorOn() 
{
  request->iotd_Req.io_Length = 1; 
  request->iotd_Req.io_Command = TD_MOTOR;
  DoIO(request);                 
}

MotorOff()
{
  request->iotd_Req.io_Length = 0; 
  request->iotd_Req.io_Command = TD_MOTOR;
  DoIO(request);                   
}

SeekTrack(Track,Seite,Sektor) 
short Track,Seite,Sektor;
{
int Offset;

Offset=Track*2*11+((11*Seite)+Sektor);
Offset*=512;
request->iotd_Req.io_Offset = Offset;
request->iotd_Req.io_Command = TD_SEEK; 
DoIO(request);                        
}

PiepSound()
{
int i;

  *DMACon=0x0001; 
for(i=1; i<100; i++) ;

  *Adresse1=(UWORD *)Pieps;
  *Period1=358;
  *Volume1=32;
  *Laenge1=345;
  *DMACon=0x8001;

for(i=1; i<100; i++) ;
  *Laenge1=1;
}


KugelFallTest()
{
short a=0,b=0,c=0,d=0,Ende=0;
ThirtyOne=0;

UnderGround(x1+8,y1);
if(Stand==0) { a=1; }
if(Stand==31 && HalfFrame2==1) a=1;
UnderGround(x1+8,y1+15);
if(Stand==0) b=1;
if(Stand==31 && HalfFrame2==1) b=1;
UnderGround(x1,y1+8);
if(Stand==0) c=1;
if(Stand==31 && HalfFrame2==1) c=1;
UnderGround(x1+15,y1+8);
if(Stand==0) d=1;
if(Stand==31 && HalfFrame2==1) { d=1; ThirtyOne=1; }

if(a && b && c && d) { KugelFallDown(); Ende=1; }

if(Ende==0 && a && c && d)
	{
	Ende=1;
        WinkelFlaecheX=0; 
        WinkelFlaecheY=-FLAECHENWINKEL2; 
	}
if(Ende==0 && b && c && d)
	{
	Ende=1;
        WinkelFlaecheX=0; 
        WinkelFlaecheY=FLAECHENWINKEL2; 
	}
if(Ende==0 && a && b && d)
	{
	Ende=1;
        WinkelFlaecheX=FLAECHENWINKEL2; 
        WinkelFlaecheY=0; 
	}
if(Ende==0 && a && b && c)
	{
	Ende=1;
        WinkelFlaecheX=-FLAECHENWINKEL2; 
        WinkelFlaecheY=0; 
	}
if(Ende==0 && a && c)
	{
	Ende=1;
        WinkelFlaecheX=-FLAECHENWINKEL2; 
        WinkelFlaecheY=-FLAECHENWINKEL2; 
	}
if(Ende==0 && a && d)
	{
	Ende=1;
        WinkelFlaecheX=FLAECHENWINKEL2; 
        WinkelFlaecheY=-FLAECHENWINKEL2; 
	}
if(Ende==0 && b && d)
	{
	Ende=1;
        WinkelFlaecheX=FLAECHENWINKEL2; 
        WinkelFlaecheY=FLAECHENWINKEL2; 
	}
if(Ende==0 && b && c)
	{
	Ende=1;
        WinkelFlaecheX=-FLAECHENWINKEL2; 
        WinkelFlaecheY=FLAECHENWINKEL2; 
	}
}

KugelFallDown()
{
int i;
	ShadowFlit(0,0,-((155-x2)/39),-((100-y2)/25),104,21); 
	ShadowFlit(0,104,-((155-x2)/39),(-((100-y2)/25))+104,104,21); 
	if(ThirtyOne==0) copl[43]=0x0000;
        AbsturzSound();
	for(i=0; i<8; i++)
		{
		DispSprite(KFall[i],x1,y1,15,0,0);
        	DispSprite((KFall[i]+72),x1,y1,15,1,1);
		Delay(2);
		x1+=(int)(vx/8);
		y1+=(int)(vy/8);
		WaitVBeam();
		*Laenge1=0;
		}
	i=0;
		DispSprite(&LeerSpr,0,0,1,0,0);
		DispSprite(&LeerSpr,0,0,1,0,1);
	Delay(50);
	RumpelSound();
	while(Wakelpattern[i]!=0)
		{
		copl[73]=Wabbelpattern[i];
		DispSprite(&LeerSpr,0,0,1,0,0);
		DispSprite(&LeerSpr,0,0,1,0,1);
		Wakel(Wakelpattern[i]);
		WaitVBeam();
		*Laenge1=0;
		i++;
		}
	WinkelY=0;
	WinkelX=0;
	WinkelBodenX=0;
	WinkelBodenY=0;
	gx=SCHWERKRAFT;
	vx=0.0;
	gy=SCHWERKRAFT;
	vy=0.0;
	k=200.0;
	sx=surex;
	sy=surey;
	sxalt=sx;
	syalt=sy;
	Senfo=1;
	x1=(int)sx;
	y1=(int)sy;
	MausAlt=(*Maus);
	MausX=155;
	MausY=104;
if(Player->Heino[Plaierbefore-1].Lives>0) Player->Heino[Plaierbefore-1].Lives--;
if(Player->Heino[Plaierbefore-1].Lives==0) { GameOver=1; PlayerON[Plaierbefore-1]=0; NewGame=1; }
copl[43]=0x0024;
}


Random(range)
int range;
{
register int ergo,ra2;

ergo=(*Zufall);
ra2=range;

while(ergo>=ra2) ergo-=ra2;
 
return ergo;
}



Glas1Sound()
{
if(s_1==2)
  {
  *Adresse1=(UWORD *)Glas1;
  *Period1=360;
  *Volume1=Volime;
  *Laenge1=1872;
  *DMACon=0x8001; 
  s_1=0;
  Busy=0;
  }
if(s_1==1) { Busy=1; *DMACon=0x0001; s_1=2; }
}


Glas2Sound()
{
if(s_2==2)
  {
  *Adresse1=(UWORD *)Glas2;
  *Period1=390;
  *Volume1=Volime;
  *Laenge1=1770;
  *DMACon=0x8001; 
  s_2=0;
Busy=0;
  }
if(s_2==1) { Busy=1; *DMACon=0x0001; s_2=2; }
}


Metal2Sound()
{
if(s_3==2)
  {
  *Adresse1=(UWORD *)Metal2;
  *Period1=360;
  *Volume1=Volime;
  *Laenge1=978;
  *DMACon=0x8001; 
  s_3=0;
 Busy=0;
  }
if(s_3==1) { Busy=1; *DMACon=0x0001; s_3=2; }
}


Metal1Sound()
{
if(s_4==2)
  {
  *Adresse1=(UWORD *)Metal1;
  *Period1=360;
  *Volume1=Volime;
  *Laenge1=1533;
  *DMACon=0x8001; 
  s_4=0;
  Busy=0;
  }
if(s_4==1) { Busy=1; *DMACon=0x0001; s_4=2; }
}


Holz1Sound()
{
if(s_5==2)
  {
  *Adresse1=(UWORD *)Holz1;
  *Period1=490;
  *Volume1=Volime;
  *Laenge1=665;
  *DMACon=0x8001; 
  s_5=0;
Busy=0;
  }
if(s_5==1) { Busy=1; *DMACon=0x0001; s_5=2; }
}


Holz2Sound()
{
if(s_6==2)
  {
  *Adresse1=(UWORD *)Holz2;
  *Period1=500;
  *Volume1=Volime;
  *Laenge1=375;
  *DMACon=0x8001; 
  s_6=0;
  Busy=0;
  }
if(s_6==1) { Busy=1; *DMACon=0x0001; s_6=2; }
}

Flummi1Sound()
{
if(s_8==2)
  {
  *Adresse3=(UWORD *)Gummi1;
  *Period3=360;
  *Volume3=Volime;
  *Laenge3=2073;
  *DMACon=0x8004; 
  s_8=0;
  Busy=0;
  }
if(s_8==1) { Busy=1; *DMACon=0x0004; s_8=2; }
}

Wakel(HowMany)
WORD HowMany;
{
HowMany*=132;
planewakel+=HowMany;
#asm
   move.l _planewakel,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
copl[49]=a2;
copl[51]=a1;
#asm
   move.l _planewakel,d3
   add.l #44,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
copl[53]=a2;
copl[55]=a1;
#asm
   move.l _planewakel,d3
   add.l #88,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
copl[57]=a2;
copl[59]=a1;
#asm
   move.l _planewakel,d3
   add.l #132,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
copl[61]=a2;
copl[63]=a1;
#asm
   move.l _planewakel,d3
   add.l #176,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
copl[65]=a2;
copl[67]=a1;
#asm
   move.l _planewakel,d3
   add.l #220,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
copl[69]=a2;
copl[71]=a1;
planewakel-=HowMany;
}


RumpelSound()
{
int i;

  *DMACon=0x0001; 
  *Adresse1=(UWORD *)Rumpel;
  *Period1=827;
  *Volume1=64;
  *Laenge1=5085;
for(i=0; i<50; i++) { }
  *DMACon=0x8001; 
}

AbsturzSound()
{
int i;

  *DMACon=0x0001; 
  *Adresse1=(UWORD *)Absturz;
  *Period1=400;
  *Volume1=64;
  *Laenge1=6684;
for(i=0; i<50; i++) { }
  *DMACon=0x8001; 
}

EinsammelSound()
{
if(s_9==2)
  {
  *Adresse2=(UWORD *)Einsammel;
  *Period2=300;
  *Volume2=64;
  *Laenge2=4374;
  *DMACon=0x8002; 
  s_9=0;
  }
if(s_9==1) { *DMACon=0x0002; s_9=2; }
}

BildAus()
{
register int i,j;

   for(j=0; j<15; j++)
    	{
 	Colors[j]=0;
	}

for(i=0; i<13; i++)
   {
   for(j=0; j<13; j++)
    	{
 	Colors3[i][j]=0;
	}
   }
#asm
   move.w #$000,$dff1a6
   move.w #$000,$dff1a8
   move.w #$000,$dff1aa
   move.w #$000,$dff1ac
   move.w #$000,$dff1ae
   move.w #$000,$dff1b0
#endasm
}

BildAn()
{
register int i,j;

   for(j=0; j<15; j++)
    	{
 	Colors[j]=Bauka1Color[j];
	}

for(i=0; i<13; i++)
   {
   for(j=0; j<13; j++)
    	{
 	Colors3[i][j]=Bauka1Color2[i][j];
	}
   }
#asm
   move.w #$22c,$dff1a6
   move.w #$22a,$dff1a8
   move.w #$6ff,$dff1aa
   move.w #$4dd,$dff1ac
   move.w #$2bb,$dff1ae
   move.w #$099,$dff1b0
#endasm
}